/*

Quixe
=====

Built: 2013-05-18

Quixe -- a Glulx VM interpreter written in Javascript
GiDispa -- a GlkAPI dispatch layer for Quixe

Designed by Andrew Plotkin <erkyrath@eblong.com>
Copyright (c) 2010-2013 Andrew Plotkin
<http://eblong.com/zarf/glulx/quixe/>

*/
Quixe=function(){function quixe_prepare(e,t){game_image=e;var r,a,n=game_image.slice(0,64);for(r=0;n.length>r;r++)a=n[r].toString(16),2>a.length&&(a="0"+a),n[r]=a;game_signature=n.join(""),t&&(opt_rethrow_exceptions=t.rethrow_exceptions)}function quixe_init(){if(vm_started)return Glk.fatal_error("Quixe was inited twice!"),void 0;try{setup_bytestring_table(),setup_operandlist_table(),setup_vm(),execute_loop()}catch(e){if(Glk.fatal_error("Quixe init: "+show_exception(e)),opt_rethrow_exceptions)throw e}}function quixe_resume(){try{done_executing=vm_stopped,execute_loop()}catch(e){if(Glk.fatal_error("Quixe run: "+show_exception(e)),opt_rethrow_exceptions)throw e}}function show_exception(e){if("string"==typeof e)return e;var t=""+e;return e.message&&(t=t+" "+e.message),e.fileName&&(t=t+" "+e.fileName),e.lineNumber&&(t=t+" line:"+e.lineNumber),e.name&&(t=t+" "+e.name),e.number&&(t=t+" "+e.number),t}function qlog(e){window.console&&console.log?console.log(e):window.opera&&opera.postError&&opera.postError(e)}function qobjdump(e,t){var r,a;if(e instanceof Array){t&&t--;var n=e.map(function(e){return qobjdump(e,t)});return"["+n.join(",")+"]"}if(!(e instanceof Object))return""+e;a=[];for(r in e){var s=e[r];t&&s instanceof Object&&(s=qobjdump(s,t-1)),a.push(r+":"+s)}return"{ "+a.join(", ")+" }"}function setup_bytestring_table(){var e,t;for(e=0;256>e;e++)t=e.toString(16),16>e&&(t="0"+t),bytestring_table[e]=t;for(e=0;256>e;e++)t=e>=32&&127>e?34==e||39==e||92==e?"\\"+String.fromCharCode(e):String.fromCharCode(e):10==e?"\\n":"\\x"+bytestring_table[e],quotechar_table[e]=t}function ByteRead4(e,t){return 16777216*e[t]+65536*e[t+1]+256*e[t+2]+e[t+3]}function ByteRead2(e,t){return 256*e[t]+e[t+1]}function ByteRead1(e,t){return e[t]}function Mem1(e){return memmap[e]}function Mem2(e){return 256*memmap[e]+memmap[e+1]}function Mem4(e){return 16777216*memmap[e]+65536*memmap[e+1]+256*memmap[e+2]+memmap[e+3]}function MemW1(e,t){memmap[e]=255&t}function MemW2(e,t){memmap[e]=255&t>>8,memmap[e+1]=255&t}function MemW4(e,t){memmap[e]=255&t>>24,memmap[e+1]=255&t>>16,memmap[e+2]=255&t>>8,memmap[e+3]=255&t}function BytePushString(e,t){for(var r=0;t.length>r;r++)e.push(t.charCodeAt(r))}function BytePush4(e,t){e.push(255&t>>24),e.push(255&t>>16),e.push(255&t>>8),e.push(255&t)}function BytePush2(e,t){e.push(255&t>>8),e.push(255&t)}function BytePush1(e,t){e.push(255&t)}function ByteWrite4(e,t,r){e[t]=255&r>>24,e[t+1]=255&r>>16,e[t+2]=255&r>>8,e[t+3]=255&r}function ByteReadString(e,t,r){return String.fromCharCode.apply(this,e.slice(t,t+r))}function QuoteMem1(e){return memmap[e]>=128?"0xffffff"+bytestring_table[memmap[e]]:"0x"+bytestring_table[memmap[e]]}function QuoteMem2(e){return memmap[e]>=128?"0xffff"+bytestring_table[memmap[e]]+bytestring_table[memmap[e+1]]:memmap[e]?"0x"+bytestring_table[memmap[e]]+bytestring_table[memmap[e+1]]:"0x"+bytestring_table[memmap[e+1]]}function QuoteMem4(e){return memmap[e]?"0x"+bytestring_table[memmap[e]]+bytestring_table[memmap[e+1]]+bytestring_table[memmap[e+2]]+bytestring_table[memmap[e+3]]:memmap[e+1]?"0x"+bytestring_table[memmap[e+1]]+bytestring_table[memmap[e+2]]+bytestring_table[memmap[e+3]]:memmap[e+2]?"0x"+bytestring_table[memmap[e+2]]+bytestring_table[memmap[e+3]]:"0x"+bytestring_table[memmap[e+3]]}function ReadArgByte(e){return 4294967295==e?255&frame.valstack.pop():Mem1(e)}function WriteArgByte(e,t){4294967295==e?frame.valstack.push(255&t):MemW1(e,t)}function ReadArgWord(e){return 4294967295==e?frame.valstack.pop():Mem4(e)}function WriteArgWord(e,t){4294967295==e?frame.valstack.push(t):MemW4(e,t)}function ReadStructField(e,t){return 4294967295==e?frame.valstack.pop():Mem4(e+4*t)}function WriteStructField(e,t,r){4294967295==e?frame.valstack.push(r):MemW4(e+4*t,r)}function SetResumeStore(e){resumevalue=e}function CharToString(e){return 65536>e?String.fromCharCode(e):(e-=65536,String.fromCharCode(55296+(e>>10),56320+(1023&e)))}function QuoteCharToString(e){if(256>e)return quotechar_table[e];if(65536>e){for(e=e.toString(16);4>e.length;)e="0"+e;return"\\u"+e}var t;return e-=65536,t=55296+(e>>10),e=56320+(1023&e),"\\u"+t.toString(16)+"\\u"+e.toString(16)}function QuoteStr1ToString(e){return QuoteCharToString(e.charCodeAt(0))}function QuoteEscapeString(e){return e=e.replace(regexp_string_unsafe,QuoteStr1ToString),'"'+e+'"'}function fatal_error(e){var t,r;if(arguments.length>1){for(e+=" (",t=1;arguments.length>t;t++)r=arguments[t],r="number"==typeof r?r.toString(16):""+r,1!=t&&(e+=" "),e+=r;e+=")"}throw qlog(e),e}function make_code(val,arg){return void 0===arg?eval("function _func() {\n"+val+"\n}"):eval("function _func("+arg+") {\n"+val+"\n}"),_func}function VMFunc(e,t,r,a){this.funcaddr=e,this.startpc=t,this.functype=Mem1(e),this.pathaddrs={},this[0]={},this[1]={},this[2]={},this.locallen=null,this.localsformat=r,this.rawformat=a,this.localsindex=[];var n,s,o=0;for(n=0;this.localsformat.length>n;n++){var i=this.localsformat[n];if(4==i.size)for(;3&o;)o++;else if(2==i.size)for(;1&o;)o++;for(s=0;i.count>s;s++)this.localsindex.push({size:i.size,pos:o}),o+=i.size}for(;3&o;)o++;this.locallen=o}function StackFrame(e){var t;for(this.vmfunc=e,this.depth=null,this.framestart=null,this.framelen=null,this.valstack=[],this.localspos=null,this.localsindex=e.localsindex,this.locals=[],t=0;this.localsindex.length>t;t++){var r=this.localsindex[t];this.locals[r.pos]=0}this.framelen=8+e.rawformat.length+e.locallen}function clone_stackframe(e){var t=new StackFrame(e.vmfunc);return t.depth=e.depth,t.framestart=e.framestart,t.framelen=e.framelen,t.valstack=e.valstack.slice(0),t.localspos=e.localspos,t.locals=e.locals.slice(0),t.framelen=e.framelen,t}function push_serialized_stackframe(e,t){BytePush4(t,e.framelen);var r=e.vmfunc.rawformat;BytePush4(t,8+r.length);for(var a=0;r.length>a;a++)t.push(r[a]);for(var a=0;e.vmfunc.localsindex.length>a;a++){var n=e.vmfunc.localsindex[a];if(4==n.size){for(;3&t.length;)t.push(0);BytePush4(t,e.locals[n.pos])}else if(2==n.size){for(;1&t.length;)t.push(0);BytePush2(t,e.locals[n.pos])}else BytePush1(t,e.locals[n.pos])}for(;3&t.length;)t.push(0);for(var a=0;e.valstack.length>a;a++)BytePush4(t,e.valstack[a])}function pop_deserialized_stackframe(e,t){var r=ByteRead4(e,e.length-4);if(0>r||r>=e.length)return qlog("Bad frameptr in serialized stack frame"),void 0;e=e.splice(r,e.length);var a=ByteRead4(e,0),n=ByteRead4(e,4);if(n!=8+t.rawformat.length)return qlog("LocalsPos in save file ("+n+")"+" doesn't match game image ("+(8+t.rawformat.length)+")"),void 0;if(a!=n+t.locallen)return qlog("FrameLen in save file ("+a+")"+" doesn't match game image ("+(n+t.locallen)+")"),void 0;var s=new StackFrame(t);s.framestart=r;for(var o=0;s.vmfunc.localsindex.length>o;o++){var i=s.vmfunc.localsindex[o];s.locals[i.pos]=4==i.size?ByteRead4(e,4+n+i.pos):2==i.size?ByteRead2(e,4+n+i.pos):ByteRead1(e,4+n+i.pos)}for(var c=a;e.length>c;c+=4)s.valstack.push(ByteRead4(e,c));return s}function VMTextEnv(e,t){0==e&&fatal_error("Tried to create a VMTextEnv for address zero."),this.addr=e,this.cacheable=void 0!==t,this.decoding_tree=t,this.vmstring_tables=[],this.cacheable&&(this.vmstring_tables[0]={},this.vmstring_tables[1]={},this.vmstring_tables[2]={})}function setup_operandlist_table(){function e(e,t){this.argsize=t?t:4,this.numops=e.length;for(var r=[],a=0;e.length>a;a++)r.push(e.charAt(a));this.formlist=r}var t=new e(""),r=new e("L"),a=new e("LL"),n=new e("LLL"),s=new e("LLLL"),o=new e("LS"),i=new e("LLS"),c=new e("LLLLLLS"),u=new e("LLLLLLLS"),l=new e("LLSS"),_=new e("LC"),f=new e("LLC"),d=new e("LLLC"),p=new e("LLLLC"),g=new e("ES"),m=new e("LES"),h=new e("EES"),v=new e("F"),w=new e("LF"),k=new e("LLF"),y=new e("EF"),b=new e("EF",1),x=new e("EF",2),M=new e("S"),S=new e("SS"),A=new e("CL"),F=new e("C");operandlist_table={0:t,16:h,17:m,18:i,19:i,20:i,21:g,24:h,25:h,26:h,27:g,28:i,29:i,30:i,32:r,34:a,35:a,36:n,37:n,38:n,39:n,40:n,41:n,42:n,43:n,44:n,45:n,48:f,49:r,50:A,51:a,52:a,64:y,65:x,66:b,68:o,69:o,72:i,73:i,74:i,75:i,76:n,77:n,78:n,79:n,80:v,81:w,82:t,83:a,84:r,112:r,113:r,114:r,115:r,256:i,257:r,258:M,259:o,260:r,272:o,273:r,288:t,289:M,290:t,291:_,292:w,293:F,294:v,295:a,304:k,320:M,321:r,328:S,329:a,336:u,337:u,338:c,352:_,353:f,354:d,355:p,368:a,369:n,376:o,377:r,384:a,385:a,400:o,401:o,402:o,408:o,409:o,416:i,417:i,418:i,419:i,420:l,424:o,425:o,426:o,427:i,432:o,433:o,434:o,435:o,436:o,437:o,438:i,448:s,449:s,450:n,451:n,452:n,453:n,456:a,457:a}}function oputil_record_funcop(e){if(0==e.mode)return"null";var t="m"+e.mode;if(null!=e.argsize&&(t=t+"s"+e.argsize),null!=e.addr&&(t=t+"a"+e.addr),funcop_cache.key)return"funcop_cache."+t;var r={key:t,mode:e.mode,argsize:e.argsize,addr:e.addr};return funcop_cache[t]=r,"funcop_cache."+t}function oputil_store(e,t,r){switch(t.mode){case 8:if(4==t.argsize){var a=r[0];if("0"===a)return e.offstack.push(r),e.code.push("// push to offstack: "+r),void 0;if("_"===a)return push_offstack_holdvar(e,r),e.code.push("// re-push to offstack: "+r),void 0}return holdvar=alloc_holdvar(e,!0),e.offstack.push(holdvar),4==t.argsize?e.code.push(holdvar+"=("+r+");"):2==t.argsize?e.code.push(holdvar+"=0xffff&("+r+");"):e.code.push(holdvar+"=0xff&("+r+");"),void 0;case 0:return e.code.push("("+r+");"),void 0;case 11:if(4==t.argsize){var a=r[0];if("0"===a)return store_offloc_value(e,t.addr,r,!1),e.code.push("// store to offloc["+t.addr+"]: "+r),void 0;if("_"===a)return store_offloc_value(e,t.addr,r,!0),e.code.push("// re-store to offloc["+t.addr+"]: "+r),void 0}return store_offloc_value(e,t.addr,void 0),4==t.argsize?e.code.push("frame.locals["+t.addr+"]=("+r+");"):2==t.argsize?e.code.push("frame.locals["+t.addr+"]=(0xffff &"+r+");"):e.code.push("frame.locals["+t.addr+"]=(0xff &"+r+");"),void 0;case 15:return 4==t.argsize?e.code.push("MemW4("+t.addr+","+r+");"):2==t.argsize?e.code.push("MemW2("+t.addr+","+r+");"):e.code.push("MemW1("+t.addr+","+r+");"),void 0;default:fatal_error("Unknown addressing mode in store func operand.")}}function oputil_push_callstub(e,t,r){void 0===r&&(r=e.cp),e.code.push("frame.valstack.push("+t+","+r+",frame.framestart);")}function oputil_push_substring_callstub(e){e.code.push("if (!substring) { substring=true;"),e.code.push("frame.valstack.push(0x11,0,nextcp,frame.framestart);"),e.code.push("}")}function oputil_unload_offstate(e,t){var r;if(e.code.push("// unload offstate: "+e.offstack.length+" stack"+(e.offloc.length?", plus locs":"")+(t?" (conditional)":"")),e.offstack.length&&e.code.push("frame.valstack.push("+e.offstack.join(",")+");"),e.offloc.length)for(r=0;e.offloc.length>r;r++)void 0!==e.offloc[r]&&e.offlocdirty[r]&&e.code.push("frame.locals["+r+"]="+e.offloc[r]+";");if(!t){var a;for(r=0;e.offloc.length>r;r++)a=e.offloc[r],void 0!==a&&void 0!==e.holduse[a]&&(e.holduse[a]=!1);for(e.offloc.length=0,e.offlocdirty.length=0;e.offstack.length;)a=e.offstack.pop(),void 0!==e.holduse[a]&&(e.holduse[a]=!1)}}function oputil_flush_string(e){if(0!=e.buffer.length){var t=e.buffer.join("");e.buffer.length=0,e.code.push("Glk.glk_put_jstring("+QuoteEscapeString(t)+");")}}function oputil_signify_operand(e,t,r){var a;if(quot_isconstant(t))return a=Number(t),2147483648&a?""+(a-4294967296):t;if(a="("+t+"&0xffffffff)",r){var n=alloc_holdvar(e);return e.code.push(n+"="+a+";"),n}return a}function oputil_decode_float(e,t,r){var a;if(quot_isconstant(t))return a=Number(t),2147483648==a?"-0":""+decode_float(a);if(a="decode_float("+t+")",r){var n=alloc_holdvar(e);return e.code.push(n+"="+a+";"),n}return a}function oputil_perform_jump(e,t,r){if(quot_isconstant(t)){var a=Number(t);if(0==a||1==a)r?(e.code.push("// quashing offstack for unconditional return: "+e.offstack.length),e.offstack.length=0,e.offloc.length=0,e.offlocdirty.length=0):e.code.push("// ignoring offstack for conditional return: "+e.offstack.length),e.code.push("leave_function();"),e.code.push("pop_callstub("+a+");");else{oputil_unload_offstate(e,!r);var n=e.cp+a-2>>>0;e.code.push("pc = "+n+";"),e.vmfunc.pathaddrs[n]=!0}}else oputil_unload_offstate(e,!r),e.code.push("if (("+t+")==0 || ("+t+")==1) {"),e.code.push("leave_function();"),e.code.push("pop_callstub("+t+");"),e.code.push("}"),e.code.push("else {"),e.code.push("pc = ("+e.cp+"+("+t+")-2) >>>0;"),e.code.push("}");e.code.push("return;")}function alloc_holdvar(e,t){for(var r,a=0;;){if(r="_hold"+a,!e.holduse[r])return e.holduse[r]=t?1:!0,r;a++}}function pop_offstack_holdvar(e){var t=e.offstack.pop();if(quot_isconstant(t))return t;var r=e.holduse[t];return(isNaN(r)||r===!1||r===!0)&&fatal_error("Offstack variable not marked as stack.",t),r--,0==r&&(r=!0),e.holduse[t]=r,t}function push_offstack_holdvar(e,t){e.offstack.push(t);var r=e.holduse[t];r&&r!==!0?r++:r=1,e.holduse[t]=r}function store_offloc_value(e,t,r,a){var n=e.offloc[t];if(n&&quot_isholdvar(n)){var s=e.holduse[n];s--,0==s&&(s=!0),e.holduse[n]=s}if(void 0===r)return e.offloc[t]=void 0,e.offlocdirty[t]=!1,void 0;if(e.offloc[t]=r,e.offlocdirty[t]=!0,a){var o=r,s=e.holduse[o];s&&s!==!0?s++:s=1,e.holduse[o]=s}}function transfer_to_offstack(e,t){for(var r;t>e.offstack.length;)r=alloc_holdvar(e,!0),e.offstack.unshift(r),e.code.push(r+"=frame.valstack.pop();")}function quot_isconstant(e){return"0"===e[0]}function quot_isholdvar(e){return"_"===e[0]}function parse_operands(e,t,r,a){var n,s,o,i,c,u,l;for(a.desttype=0,a.numops=r.numops,n=t,t+=r.numops+1>>1,s=0;r.numops>s;s++){0==(1&s)?(o=Mem1(n),i=15&o):(i=15&o>>4,n++);var _=r.formlist[s];if("L"!=_)if("E"!=_)if("S"!=_)if("F"!=_)if("C"!=_)fatal_error("Unknown operand type.",_);else{switch(i){case 8:a[s]="3,0";continue;case 0:a[s]="0,0";continue}if(i>=9&&11>=i){9==i?(u=Mem1(t),t++):10==i?(u=Mem2(t),t+=2):11==i&&(u=Mem4(t),t+=4),a[s]="2,"+u;continue}switch(i){case 15:u=Mem4(t)+ramstart,t+=4;break;case 14:u=Mem2(t)+ramstart,t+=2;break;case 13:u=Mem1(t)+ramstart,t++;break;case 7:u=Mem4(t),t+=4;break;case 6:u=Mem2(t),t+=2;break;case 5:u=Mem1(t),t++;break;default:fatal_error("Unknown addressing mode in store operand.")}a[s]="1,"+u}else{var f=a.func_store;switch(i){case 8:f.mode=8,f.argsize=r.argsize,a[s]=f;continue;case 0:f.mode=0,f.argsize=r.argsize,a[s]=f;continue}if(i>=9&&11>=i){9==i?(u=Mem1(t),t++):10==i?(u=Mem2(t),t+=2):11==i&&(u=Mem4(t),t+=4),f.mode=11,f.addr=u,f.argsize=r.argsize,a[s]=f;continue}switch(i){case 15:u=Mem4(t)+ramstart,t+=4;break;case 14:u=Mem2(t)+ramstart,t+=2;break;case 13:u=Mem1(t)+ramstart,t++;break;case 7:u=Mem4(t),t+=4;break;case 6:u=Mem2(t),t+=2;break;case 5:u=Mem1(t),t++;break;default:fatal_error("Unknown addressing mode in store operand.")}f.mode=15,f.addr=u,f.argsize=r.argsize,a[s]=f}else{switch(i){case 8:l=alloc_holdvar(e,!0),e.offstack.push(l),a[s]=l+"=(";continue;case 0:a[s]="(";continue}if(i>=9&&11>=i){9==i?(u=Mem1(t),t++):10==i?(u=Mem2(t),t+=2):11==i&&(u=Mem4(t),t+=4),4==r.argsize?(l=alloc_holdvar(e,!0),store_offloc_value(e,u,l,!1),a[s]=l+"=("):2==r.argsize?(store_offloc_value(e,u,void 0),a[s]="frame.locals["+u+"]=(0xffff &"):(store_offloc_value(e,u,void 0),a[s]="frame.locals["+u+"]=(0xff &");continue}switch(i){case 15:u=Mem4(t)+ramstart,t+=4;break;case 14:u=Mem2(t)+ramstart,t+=2;break;case 13:u=Mem1(t)+ramstart,t++;break;case 7:u=Mem4(t),t+=4;break;case 6:u=Mem2(t),t+=2;break;case 5:u=Mem1(t),t++;break;default:fatal_error("Unknown addressing mode in store operand.")}c=4==r.argsize?"MemW4("+u+",":2==r.argsize?"MemW2("+u+",":"MemW1("+u+",",a[s]=c}else{switch(i){case 8:a[s]=e.offstack.length?pop_offstack_holdvar(e):"frame.valstack.pop()";continue;case 0:a[s]="0";continue;case 1:c=QuoteMem1(t),t++,a[s]=c;continue;case 2:c=QuoteMem2(t),t+=2,a[s]=c;continue;case 3:c=QuoteMem4(t),t+=4,a[s]=c;continue}if(i>=9&&11>=i){if(9==i?(u=Mem1(t),t++):10==i?(u=Mem2(t),t+=2):11==i&&(u=Mem4(t),t+=4),void 0!==e.offloc[u]){a[s]=e.offloc[u];continue}c=4==r.argsize?"frame.locals["+u+"]":2==r.argsize?"frame.locals["+u+"] & 0xffff":"frame.locals["+u+"] & 0xff",l=alloc_holdvar(e,!0),e.code.push(l+"=("+c+");"),e.offloc[u]=l,e.offlocdirty[u]=!1,a[s]=l;continue}switch(i){case 15:u=Mem4(t)+ramstart,t+=4;break;case 14:u=Mem2(t)+ramstart,t+=2;break;case 13:u=Mem1(t)+ramstart,t++;break;case 7:u=Mem4(t),t+=4;break;case 6:u=Mem2(t),t+=2;break;case 5:u=Mem1(t),t++;break;default:fatal_error("Unknown addressing mode in load operand.")}c=4==r.argsize?"Mem4("+u+")":2==r.argsize?"Mem2("+u+")":"Mem1("+u+")",a[s]=c}else{switch(i){case 8:e.offstack.length?a[s]=pop_offstack_holdvar(e):(l=alloc_holdvar(e),e.code.push(l+"=frame.valstack.pop();"),a[s]=l);continue;case 0:a[s]="0";continue;case 1:c=QuoteMem1(t),t++,a[s]=c;continue;case 2:c=QuoteMem2(t),t+=2,a[s]=c;continue;case 3:c=QuoteMem4(t),t+=4,a[s]=c;continue}if(i>=9&&11>=i){if(9==i?(u=Mem1(t),t++):10==i?(u=Mem2(t),t+=2):11==i&&(u=Mem4(t),t+=4),void 0!==e.offloc[u]){a[s]=e.offloc[u];continue}c=4==r.argsize?"frame.locals["+u+"]":2==r.argsize?"frame.locals["+u+"] & 0xffff":"frame.locals["+u+"] & 0xff",l=alloc_holdvar(e,!0),e.code.push(l+"=("+c+");"),e.offloc[u]=l,e.offlocdirty[u]=!1,a[s]=l;continue}switch(i){case 15:u=Mem4(t)+ramstart,t+=4;break;case 14:u=Mem2(t)+ramstart,t+=2;break;case 13:u=Mem1(t)+ramstart,t++;break;case 7:u=Mem4(t),t+=4;break;case 6:u=Mem2(t),t+=2;break;case 5:u=Mem1(t),t++;break;default:fatal_error("Unknown addressing mode in load operand.")}c=4==r.argsize?"Mem4("+u+")":2==r.argsize?"Mem2("+u+")":"Mem1("+u+")",l=alloc_holdvar(e),e.code.push(l+"=("+c+");"),a[s]=l}}return t}function compile_func(e){var t=e,r=Mem1(t);192!=r&&193!=r&&(r>=192&&223>=r?fatal_error("Call to unknown type of function.",t):fatal_error("Call to non-function.",t)),t++;for(var a=[],n=t;;){var s=Mem1(t);t++;var o=Mem1(t);if(t++,0==s)break;1!=s&&2!=s&&4!=s&&fatal_error("Invalid local variable size in function header.",s),a.push({size:s,count:o})}for(var i=memmap.slice(n,t);i.length%4;)i.push(0);return new VMFunc(e,t,a,i)}function compile_path(e,t,r){var a,n,s,o=t,i={vmfunc:e,cp:null,curiosys:r,code:[],holduse:{},varsused:{},offstack:[],offloc:[],offlocdirty:[],path_ends:!1},c={};for(c.func_store={},i.code.push("");!i.path_ends;){n=o,a=Mem1(o),void 0===a&&fatal_error("Tried to compile nonexistent address",o),o++,128&a&&(64&a?(a&=63,a=256*a|Mem1(o),o++,a=256*a|Mem1(o),o++,a=256*a|Mem1(o),o++):(a&=127,a=256*a|Mem1(o),o++)),i.code.push("// "+n.toString(16)+": opcode "+a.toString(16));var u=operandlist_table[a];u||fatal_error("Encountered unknown opcode.",a),o=parse_operands(i,o,u,c),i.cp=o;var l=opcode_table[a];l||fatal_error("Encountered unhandled opcode.",a),l(i,c);for(s in i.holduse)i.holduse[s]===!0&&(i.holduse[s]=!1);i.offstack.length&&i.code.push("// offstack: "+i.offstack.join(",")),i.offloc.length&&i.code.push("// offloc: "+i.offloc.join(",")+"; dirty: "+i.offlocdirty.join(",")),e.pathaddrs[o]&&!i.path_ends&&(i.code.push("// reached jump-in point"),i.code.push("pc="+o+";"),oputil_unload_offstate(i),i.code.push("return;"),i.path_ends=!0)}i.offstack.length&&fatal_error("Path compilation ended with nonempty offstack.",i.offstack.length),i.offloc.length&&fatal_error("Path compilation ended with nonempty offloc.",i.offloc.length);var _=[];for(s in i.holduse)_.push(s);for(s in i.varsused)_.push(s);return _.length&&(i.code[0]="var "+_.join(",")+";"),make_code(i.code.join("\n"))}function enter_function(e,t){var r;total_function_calls++;var a=accel_address_map[e];if(void 0!==a){accel_function_calls++;var n=a(t,tempcallargs);return pop_callstub(n),void 0}var s=vmfunc_table[e];void 0===s&&(s=compile_func(e),ramstart>e&&(vmfunc_table[e]=s)),pc=s.startpc;var o=new StackFrame(s);if(o.depth=stack.length,o.framestart=0==stack.length?0:frame.framestart+frame.framelen+4*frame.valstack.length,stack.push(o),frame=o,192==s.functype){for(r=t-1;r>=0;r--)frame.valstack.push(tempcallargs[r]);frame.valstack.push(t)}else for(r=0;t>r;r++){var i=s.localsindex[r];if(void 0===i)break;4==i.size?frame.locals[i.pos]=tempcallargs[r]:2==i.size?frame.locals[i.pos]=65535&tempcallargs[r]:1==i.size&&(frame.locals[i.pos]=255&tempcallargs[r])}}function leave_function(){var e=frame.depth;if(stack.pop(),0==stack.length)throw frame=null,ReturnedFromMain;frame=stack[stack.length-1],frame.depth!=e-1&&fatal_error("Stack inconsistent after function exit.")}function pop_stack_to(e){for(;stack.length&&stack[stack.length-1].framestart>e;)stack.pop();0==stack.length&&fatal_error("Stack evaporated during throw."),frame=stack[stack.length-1],e-=frame.framestart+frame.framelen,0>e&&fatal_error("Attempted to throw below the frame value stack."),3&e&&fatal_error("Attempted to throw to an unaligned address."),e>>>=2,e>frame.valstack.length&&fatal_error("Attempted to throw beyond the frame value stack."),frame.valstack.length=e}function pop_callstub(e){var t,r;isNaN(e)&&fatal_error("Function returned undefined value.");var a=frame.valstack.pop();switch(a!=frame.framestart&&fatal_error("Call stub frameptr ("+a+") "+"does not match frame ("+frame.framestart+")"),pc=frame.valstack.pop(),t=frame.valstack.pop(),r=frame.valstack.pop()){case 0:return;case 1:return MemW4(t,e),void 0;case 2:return frame.locals[t]=e,void 0;case 3:return frame.valstack.push(e),void 0;case 17:return fatal_error("String-terminator call stub at end of function call."),void 0;case 16:return stream_string(0,pc,225,t),void 0;case 18:return stream_num(0,pc,!0,t),void 0;case 19:return stream_string(0,pc,224,t),void 0;case 20:return stream_string(0,pc,226,t),void 0;default:fatal_error("Unrecognized desttype in callstub.",r)}}function store_operand(e,t,r){switch(e){case 0:return;case 1:return MemW4(t,r),void 0;case 2:return frame.locals[t]=r,void 0;case 3:return frame.valstack.push(r),void 0;default:fatal_error("Unrecognized desttype in callstub.",e)}}function store_operand_by_funcop(e,t){if(e)switch(e.mode){case 8:return frame.valstack.push(t),void 0;case 0:return;case 11:return frame.locals[e.addr]=4==e.argsize?t:2==e.argsize?65535&t:255&t,void 0;case 15:return 4==e.argsize?MemW4(e.addr,t):2==e.argsize?MemW2(e.addr,t):MemW1(e.addr,t),void 0;default:fatal_error("Unknown addressing mode in store func by operand.")}}function set_random(e){0==e?random_func=Math.random:(srand_set_seed(e),random_func=srand_get_random)}function srand_set_seed(e){var t,r,a,n,s;for(void 0===srand_table&&(srand_table=Array(55)),srand_table[54]=e,srand_index1=0,srand_index2=31,a=1,t=0;55>t;t++)r=21*t%55,srand_table[r]=a,a=e-a>>>0,e=srand_table[r];for(s=0;4>s;s++)for(t=0;55>t;t++)n=srand_table[t]-srand_table[(1+t+30)%55],srand_table[t]=n>>>0}function srand_get_random(){return srand_index1=(srand_index1+1)%55,srand_index2=(srand_index2+1)%55,srand_table[srand_index1]=srand_table[srand_index1]-srand_table[srand_index2]>>>0,srand_table[srand_index1]/4294967296}function accel_helper_obj_in_class(e){return Mem4(e+13+accel_params[7])==accel_params[2]}function accel_helper_get_prop(e,t){var r,a=0;if(4294901760&t){if(a=Mem4(accel_params[0]+4*(65535&t)),accel_helper_temp_args[0]=e,accel_helper_temp_args[1]=a,0==accel_func_map[5](2,accel_helper_temp_args))return 0;t>>=16,e=a}return accel_helper_temp_args[0]=e,accel_helper_temp_args[1]=t,r=accel_func_map[2](2,accel_helper_temp_args),0==r?0:accel_helper_obj_in_class(e)&&0==a&&(accel_params[1]>t||t>=accel_params[1]+8)?0:Mem4(accel_params[6])!=e&&1&Mem1(r+9)?0:r}function set_string_table(e){if(stringtable!=e&&(decoding_tree=void 0,vmstring_table=void 0,stringtable=e,0!=stringtable)){var t=vmtextenv_table[stringtable];if(void 0===t){var r=void 0,a=Mem4(stringtable),n=Mem4(stringtable+8),s=ramstart>=stringtable+a;if(s){var o=Array(1);build_decoding_tree(o,n,4,0),r=o[0],void 0===r&&fatal_error("Failed to create decoding tree.")}t=new VMTextEnv(stringtable,r),vmtextenv_table[stringtable]=t}decoding_tree=t.decoding_tree,vmstring_table=t.vmstring_tables[iosysmode]}}function set_iosys(e,t){switch(e){case 0:t=0;break;case 1:break;case 2:t=0;break;default:e=0,t=0}iosysmode=e,iosysrock=t;var r=vmtextenv_table[stringtable];vmstring_table=void 0===r?void 0:r.vmstring_tables[iosysmode]}function build_decoding_tree(e,t,r,a){var n,s,o,i;if(s=Mem1(t),0==s&&4==r)return o=Array(16),o.type=0,o.depth=4,e[a]=o,build_decoding_tree(o,t,0,0),void 0;if(0==s){var c=Mem4(t+1),u=Mem4(t+5);return build_decoding_tree(e,c,r+1,a),build_decoding_tree(e,u,r+1,a|1<<r),void 0}switch(t++,o={},o.type=s,o.depth=r,s){case 2:o.value=Mem1(t),o.cchar=CharToString(o.value);break;case 4:o.value=Mem4(t),o.cchar=CharToString(o.value);break;case 3:case 5:o.addr=t;break;case 8:case 9:o.addr=Mem4(t);break;case 10:case 11:o.addr=t;break;case 1:break;default:fatal_error("Unknown node type in string table.",s)}for(i=1<<r,n=a;16>n;n+=i)e[n]=o}function stream_num(e,t,r,a){var n=(4294967295&t).toString(10);switch(iosysmode){case 2:a&&(n=n.slice(a)),Glk.glk_put_jstring(n,!0);break;case 1:if(r||(frame.valstack.push(17,0,e,frame.framestart),r=!0),n.length>a){var s=n.charCodeAt(a);return frame.valstack.push(18,a+1,t,frame.framestart),tempcallargs[0]=s,enter_function(iosysrock,1),!0}break;case 0:}if(r){var o,i;frame.valstack.pop()!=frame.framestart&&fatal_error("Call stub frameptr does not match frame."),pc=frame.valstack.pop(),i=frame.valstack.pop(),o=frame.valstack.pop(),17!=o&&fatal_error("String-on-string call stub while printing number.")}}function stream_string(e,t,r,a){for(var n,s,o,i,c,u=0!=r;;){if(s=void 0,n=0==r?t:t+"/"+r+"/"+a,void 0!==vmstring_table?(s=vmstring_table[n],void 0===s&&(s=compile_string(iosysmode,t,r,a),vmstring_table[n]=s,strings_compiled++,strings_cached++)):(s=compile_string(iosysmode,t,r,a),strings_compiled++),s instanceof Function){if(o=s(e,u),o instanceof Array){u=!0,t=o[0],r=o[1],a=o[2];continue}if(o)return!0}else if(Glk.glk_put_jstring(s),!u)return!1;if(frame.valstack.pop()!=frame.framestart&&fatal_error("Call stub frameptr does not match frame."),pc=frame.valstack.pop(),c=frame.valstack.pop(),i=frame.valstack.pop(),17==i)return!0;16==i?(u=!0,a=c,r=225,t=pc):fatal_error("Function-terminator call stub at end of string.")}}function compile_string(e,t,r,a){var n,s,o=t,i=a,c=void 0;o||fatal_error("Called compile_string with null address.");var u={startaddr:t,startbitnum:a,buffer:[],code:[]};if(0==r?(s=Mem1(o),226==s?o+=4:o++,i=0):s=r,225==s)if(decoding_tree){var l,_,f,d,p,g,m=!1;for(l=Mem1(o),i&&(l>>=i),_=8-i,f=!1,decoding_tree instanceof Array||(m=!0),p=decoding_tree;!m;){if(4>_){var h=Mem1(o+1);l|=h<<_,_+=8,f=!0}if(g=p[15&l],_-=g.depth,l>>=g.depth,i+=g.depth,i>=8)if(o+=1,i-=8,f)f=!1;else{var h=Mem1(o);l|=h<<_,_+=8}if(g instanceof Array)p=g;else switch(g.type){case 1:m=!0;break;case 2:case 4:switch(e){case 2:u.buffer.push(g.cchar);break;case 1:oputil_flush_string(u),oputil_push_substring_callstub(u),oputil_push_callstub(u,"0x10,"+i,o),u.code.push("tempcallargs[0]="+g.value+";"),u.code.push("enter_function(iosysrock, 1);"),c=!0,m=!0}p=decoding_tree;break;case 3:switch(e){case 2:for(d=g.addr;;){if(n=Mem1(d),0==n)break;u.buffer.push(CharToString(n)),d++}break;case 1:oputil_flush_string(u),oputil_push_substring_callstub(u),oputil_push_callstub(u,"0x10,"+i,o),c="["+g.addr+", 0xE0, 0]",m=!0}p=decoding_tree;break;case 5:switch(e){case 2:for(d=g.addr;;){if(n=Mem4(d),0==n)break;u.buffer.push(CharToString(n)),d+=4}break;case 1:oputil_flush_string(u),oputil_push_substring_callstub(u),oputil_push_callstub(u,"0x10,"+i,o),c="["+g.addr+", 0xE2, 0]",m=!0}p=decoding_tree;break;case 8:case 9:case 10:case 11:oputil_flush_string(u),oputil_push_substring_callstub(u),u.code.push("var otype, retval;"),u.code.push("var oaddr = "+g.addr+";"),g.type>=9&&u.code.push("oaddr = Mem4(oaddr);"),11==g.type&&u.code.push("oaddr = Mem4(oaddr);"),u.code.push("otype = Mem1(oaddr);"),c="retval",m=!0,oputil_push_callstub(u,"0x10,"+i,o),u.code.push("if (otype >= 0xE0 && otype <= 0xFF) {"),u.code.push("retval = [oaddr, 0, 0];"),u.code.push("}"),u.code.push("else if (otype >= 0xC0 && otype <= 0xDF) {");var v=0;if(10==g.type||11==g.type){v=Mem4(g.addr+4);for(var w=0;v>w;w++)u.code.push("tempcallargs["+w+"]="+Mem4(g.addr+8+4*w)+";")}u.code.push("enter_function(oaddr, "+v+");"),u.code.push("retval = true;"),u.code.push("}"),u.code.push("else {"),u.code.push("fatal_error('Unknown object while decoding string indirect reference.', otype);"),u.code.push("}");break;default:fatal_error("Unknown entity in string decoding (cached).")}}}else{var k,y,b,m=!1;for(stringtable||fatal_error("Attempted to print a compressed string with no table set."),y=Mem1(o),i&&(y>>=i),k=Mem4(stringtable+8);!m;)switch(b=Mem1(k),k++,b){case 0:k=1&y?Mem4(k+4):Mem4(k+0),7==i?(i=0,o++,y=Mem1(o)):(i++,y>>=1);break;case 1:c=!1,m=!0;break;case 2:switch(n=Mem1(k),e){case 2:u.buffer.push(CharToString(n));break;case 1:oputil_flush_string(u),oputil_push_substring_callstub(u),oputil_push_callstub(u,"0x10,"+i,o),u.code.push("tempcallargs[0]="+n+";"),u.code.push("enter_function(iosysrock, 1);"),c=!0,m=!0}k=Mem4(stringtable+8);break;case 4:switch(n=Mem4(k),e){case 2:u.buffer.push(CharToString(n));break;case 1:oputil_flush_string(u),oputil_push_substring_callstub(u),oputil_push_callstub(u,"0x10,"+i,o),u.code.push("tempcallargs[0]="+n+";"),u.code.push("enter_function(iosysrock, 1);"),c=!0,m=!0}k=Mem4(stringtable+8);break;case 3:switch(e){case 2:for(;;){if(n=Mem1(k),0==n)break;u.buffer.push(CharToString(n)),k++}break;case 1:oputil_flush_string(u),oputil_push_substring_callstub(u),oputil_push_callstub(u,"0x10,"+i,o),c="["+k+", 0xE0, 0]",m=!0}k=Mem4(stringtable+8);break;case 5:switch(e){case 2:for(;;){if(n=Mem4(k),0==n)break;u.buffer.push(CharToString(n)),k+=4}break;case 1:oputil_flush_string(u),oputil_push_substring_callstub(u),oputil_push_callstub(u,"0x10,"+i,o),c="["+k+", 0xE2, 0]",m=!0}k=Mem4(stringtable+8);break;case 8:case 9:case 10:case 11:oputil_flush_string(u),oputil_push_substring_callstub(u),u.code.push("var otype, retval;"),u.code.push("var oaddr = "+Mem4(k)+";"),(9==b||11==b)&&u.code.push("oaddr = Mem4(oaddr);"),u.code.push("otype = Mem1(oaddr);"),c="retval",m=!0,oputil_push_callstub(u,"0x10,"+i,o),u.code.push("if (otype >= 0xE0 && otype <= 0xFF) {"),u.code.push("retval = [oaddr, 0, 0];"),u.code.push("}"),u.code.push("else if (otype >= 0xC0 && otype <= 0xDF) {");var v=0;if(10==b||11==b){v=Mem4(k+4);for(var w=0;v>w;w++)u.code.push("tempcallargs["+w+"]="+Mem4(k+8+4*w)+";")}u.code.push("enter_function(oaddr, "+v+");"),u.code.push("retval = true;"),u.code.push("}"),u.code.push("else {"),u.code.push("fatal_error('Unknown object while decoding string indirect reference.', otype);"),u.code.push("}");break;default:fatal_error("Unknown entity in string decoding.",b)}}else if(224==s){var n;switch(e){case 2:for(;;){if(n=Mem1(o),o++,0==n)break;u.buffer.push(CharToString(n))}break;case 1:oputil_flush_string(u),oputil_push_substring_callstub(u),n=Mem1(o),o++,0!=n?(oputil_push_callstub(u,"0x13,0",o),u.code.push("tempcallargs[0]="+n+";"),u.code.push("enter_function(iosysrock, 1);"),c=!0):c="false"}}else if(226==s){var n;switch(e){case 2:for(;;){if(n=Mem4(o),o+=4,0==n)break;u.buffer.push(CharToString(n))}break;case 1:oputil_flush_string(u),oputil_push_substring_callstub(u),n=Mem4(o),o+=4,0!=n?(oputil_push_callstub(u,"0x14,0",o),u.code.push("tempcallargs[0]="+n+";"),u.code.push("enter_function(iosysrock, 1);"),c=!0):c="false"}}else s>=224&&255>=s?fatal_error("Attempt to print unknown type of string."):fatal_error("Attempt to print non-string.");return c?(oputil_flush_string(u),u.code.push("return "+c+";"),make_code(u.code.join("\n"),"nextcp,substring")):(u.code.length&&fatal_error("Simple-case string generated code."),u.buffer.join(""))}function do_gestalt(e,t){switch(e){case 0:return 196866;case 1:return 65793;case 2:return 1;case 3:return 1;case 4:switch(t){case 0:return 1;case 1:return 1;case 2:return 1;default:return 0}break;case 5:return 1;case 6:return 1;case 7:return 1;case 8:return heap_get_start();case 9:return 1;case 10:return accel_func_map[t]?1:0;case 11:return 1;default:return 0}}function fetch_search_key(e,t,r){var a;if(tempsearchkey.length=t,1&r)for(a=0;t>a;a++)tempsearchkey[a]=Mem1(e+a);else switch(t){case 4:tempsearchkey[0]=255&e>>24,tempsearchkey[1]=255&e>>16,tempsearchkey[2]=255&e>>8,tempsearchkey[3]=255&e;break;case 2:tempsearchkey[0]=255&e>>8,tempsearchkey[1]=255&e;break;case 1:tempsearchkey[0]=255&e;break;default:throw"Direct search key must hold one, two, or four bytes."
}return tempsearchkey}function linear_search(e,t,r,a,n,s,o){var i,c,u,l,_=0!=(4&o),f=0!=(2&o),d=fetch_search_key(e,t,o);for(c=0;n>c;c++,r+=a){for(u=!0,i=0;u&&t>i;i++)l=Mem1(r+s+i),l!=d[i]&&(u=!1);if(u)return _?c:r;if(f){for(u=!0,i=0;u&&t>i;i++)l=Mem1(r+s+i),0!=l&&(u=!1);if(u)break}}return _?4294967295:0}function binary_search(e,t,r,a,n,s,o){var i,c,u,l,_,f,d,p,g=0!=(4&o),m=fetch_search_key(e,t,o);for(c=0,i=n;i>c;){for(_=0,l=i+c>>1,u=r+l*a,f=0;!_&&t>f;f++)d=Mem1(u+s+f),p=m[f],p>d?_=-1:d>p&&(_=1);if(!_)return g?l:u;0>_?c=l+1:i=l}return g?4294967295:0}function linked_search(e,t,r,a,n,s){for(var o,i,c,u=0!=(2&s),l=fetch_search_key(e,t,s);0!=r;){for(c=!0,o=0;c&&t>o;o++)i=Mem1(r+a+o),i!=l[o]&&(c=!1);if(c)return r;if(u){for(c=!0,o=0;c&&t>o;o++)i=Mem1(r+a+o),0!=i&&(c=!1);if(c)break}r=Mem4(r+n)}return 0}function decode_float(e){var t,r,a;return 2147483648&e?(t=!0,e=2147483647&e):t=!1,0==e?t?-0:0:2139095040==(2139095040&e)?0==(8388607&e)?t?-1/0:1/0:t?0/0:0/0:(a=255&e>>23,r=a?(8388608|8388607&e)/8388608*Math.pow(2,a-127):(8388607&e)/8388608*Math.pow(2,-126),t?-r:r)}function encode_float(e){var t,r,a,n,s;return isNaN(e)?2139095041:isFinite(e)?0==e?0>1/e?2147483648:0:(0>e?(s=!0,t=-e):(s=!1,t=e),n=Math.floor(Math.log(t)/Math.log(2)),a=t/Math.pow(2,n),n>=128?s?4286578688:2139095040:(-126>n?(a*=Math.pow(2,126+n),n=0):(0!=n||0!=a)&&(n+=127,a-=1),a=8388608*a,r=a+.4999999999999999<<0,r>=8388608&&(r=0,n++,n>=255)?s?4286578688:2139095040:s?(2147483648|n<<23|r)>>>0:n<<23|r)):0>e?4286578688:2139095040}function setup_vm(){var e,t;game_image||fatal_error("There is no Glulx game file loaded."),vm_started=!0,resumefuncop=null,resumevalue=0,memmap=null,stack=[],frame=null,pc=0,36>game_image.length&&fatal_error("This is too short to be a valid Glulx file."),e=ByteRead4(game_image,0),1198290284!=e&&fatal_error("This is not a valid Glulx file."),t=ByteRead4(game_image,4),131072>t&&fatal_error("This Glulx file is too old a version to execute."),t>=197120&&fatal_error("This Glulx file is too new a version to execute."),ramstart=ByteRead4(game_image,8),endgamefile=ByteRead4(game_image,12),origendmem=ByteRead4(game_image,16),stacksize=ByteRead4(game_image,20),startfuncaddr=ByteRead4(game_image,24),origstringtable=ByteRead4(game_image,28),checksum=ByteRead4(game_image,32),protectstart=0,protectend=0,(256>ramstart||ramstart>endgamefile||endgamefile>origendmem)&&fatal_error("The segment boundaries in the header are in an impossible order."),endgamefile!=game_image.length&&fatal_error("The game file length does not agree with the header."),done_executing=!1,vmfunc_table={},vmtextenv_table={},decoding_tree=void 0,vmstring_table=void 0,tempcallargs=Array(8),tempglkargs=Array(1),set_random(0),endmem=origendmem,stringtable=0,undostack=[],heapstart=0,usedlist=[],freelist=[],vm_restart()}function vm_restart(){heap_clear();var e=copy_protected_range();memmap=null,memmap=game_image.slice(0,endgamefile),endmem=memmap.length,change_memsize(origendmem,!1),paste_protected_range(e),stack=[],frame=null,pc=0,iosysmode=0,iosysrock=0,set_string_table(origstringtable),enter_function(startfuncaddr,0)}function compress_bytes(e){result=[];for(var t=0;e.length>t;){for(var r=0;e.length>t&&0==e[t]&&255>=r;)r++,t++;for(r>0&&(result.push(0),result.push(r-1));e.length>t&&0!=e[t];)result.push(e[t]),t++}return result}function decompress_bytes(e){result=[];for(var t=0;e.length>t;){var r=e[t++];if(0==r)for(var a=e[t++]+1,n=0;a>n;n++)result.push(0);else result.push(r)}return result}function pack_iff_chunks(e){keys=[];for(var t in e)4!=t.length&&fatal_error("Bad chunk ID (must be exactly 4 chars): "+t),keys.push(t);keys.sort(),bytes=[];for(var r=0;keys.length>r;r++){var t=keys[r],a=e[t];BytePushString(bytes,t),BytePush4(bytes,a.length),bytes=bytes.concat(a)}return bytes}function unpack_iff_chunks(e){chunks={};for(var t=0;e.length>t;){if(t+8>e.length)return qlog("IFF chunk header is truncated"),void 0;var r=ByteReadString(e,t,4),a=ByteRead4(e,t+4);if(t+=8,t+a>e.length)return qlog(r+" chunk is truncated "+"("+a+" bytes needed, "+(e.length-t)+" available"),void 0;chunks[r]=e.slice(t,t+a),t+=a}return chunks}function vm_save(e){memmap.length!=endmem&&fatal_error("Memory length was incorrect before save."),2!=iosysmode&&fatal_error("Streams are only available in Glk I/O system.");var t=GiDispa.class_obj_from_id("stream",e);if(!t)return!1;chunks={},chunks.IFhd=game_image.slice(0,128),chunks.CMem=memmap.slice(ramstart);for(var r=ramstart;game_image.length>r;r++)chunks.CMem[r-ramstart]^=game_image[r];chunks.CMem=compress_bytes(chunks.CMem),chunks.QFun=[];for(var r=0;stack.length>r;r++)BytePush4(chunks.QFun,stack[r].vmfunc.funcaddr);chunks.Stks=[];for(var r=0;stack.length>r;r++)push_serialized_stackframe(stack[r],chunks.Stks);if(heap_is_active()){chunks.MAll=[],BytePush4(chunks.MAll,heapstart),BytePush4(chunks.MAll,usedlist.length);for(var r=0;usedlist.length>r;r++)BytePush4(chunks.MAll,usedlist[r].addr),BytePush4(chunks.MAll,usedlist[r].size)}var a=[];BytePushString(a,"IFZS"),a=a.concat(pack_iff_chunks(chunks));var n=pack_iff_chunks({FORM:a});return Glk.glk_put_buffer_stream(t,n),!0}function vm_restore(e){2!=iosysmode&&fatal_error("Streams are only available in Glk I/O system.");var t=GiDispa.class_obj_from_id("stream",e);if(!t)return!1;for(var r=Array(0),a=Array(1024),n=1;n>0;)n=Glk.glk_get_buffer_stream(t,a),r=r.concat(a.slice(0,n));if(r=unpack_iff_chunks(r),!r)return qlog("vm_restore failed: file is not Quetzal"),!1;if(r=r.FORM,!r||"IFZS"!=ByteReadString(r,0,4))return qlog("vm_restore failed: file doesn't start with FORM/IFZS header"),!1;var s=unpack_iff_chunks(r.slice(4));if(!s.IFhd)return qlog("vm_restore failed: missing required IFhd chunk"),!1;for(var o=0;128>o;o++)if(s.IFhd[o]!=game_image[o])return qlog("vm_restore failed: this save image is for a different game"),!1;if(!s.CMem)return qlog("vm_restore failed: missing required CMem chunk"),!1;s.QFun||qlog("vm_restore failed: missing required QFun chunk"),s.Stks||qlog("vm_restore failed: missing required Stks chunk");var i=copy_protected_range();heap_clear();var c=decompress_bytes(s.CMem);change_memsize(ramstart+c.length,!1),memmap=game_image.slice(0,ramstart).concat(c);for(var o=ramstart;game_image.length>o;o++)memmap[o]^=game_image[o];for(var u=[],l=0;s.QFun.length>l;l+=4){var _=ByteRead4(s.QFun,l),f=vmfunc_table[_];void 0===f&&(f=compile_func(_),ramstart>_&&(vmfunc_table[_]=f)),u.push(f)}stack=[];for(var o=u.length-1;o>=0;o--)frame=pop_deserialized_stackframe(s.Stks,u[o]),frame||fatal_error("vm_restore failed: bad stack frame"),stack.unshift(frame);for(var o=0;stack.length>o;o++)stack[o].depth=o;if(frame=stack[stack.length-1],s.MAll){heapstart=ByteRead4(s.MAll,0);for(var d=ByteRead4(s.MAll,4),p=heapstart,o=0;d>o;o++){var _=ByteRead4(s.MAll,8+4*o),g=ByteRead4(s.MAll,12+4*o);(p>_||_+g>endmem)&&fatal_error("vm_restore failed: corrupt dynamic heap"),usedlist.push(new HeapBlock(_,g)),_>p&&freelist.push(new HeapBlock(p,_-p)),p=_+g}endmem>p&&freelist.push(new HeapBlock(p,endmem-p))}return paste_protected_range(i),!0}function vm_saveundo(){memmap.length!=endmem&&fatal_error("Memory length was incorrect before saveundo.");var e={};e.ram=memmap.slice(ramstart),e.endmem=endmem,e.pc=pc,e.stack=[];for(var t=0;stack.length>t;t++)e.stack[t]=clone_stackframe(stack[t]);e.heapstart=heapstart,e.usedlist=usedlist.slice(0),e.freelist=freelist.slice(0),undostack.push(e),undostack.length>10&&undostack.shift()}function vm_restoreundo(){if(0==undostack.length)return!1;var e=undostack.pop(),t=copy_protected_range();return memmap=memmap.slice(0,ramstart).concat(e.ram),endmem=e.endmem,stack=e.stack,frame=stack[stack.length-1],pc=e.pc,heapstart=e.heapstart,usedlist=e.usedlist,freelist=e.freelist,paste_protected_range(t),memmap.length!=endmem&&fatal_error("Memory length was incorrect after undo."),!0}function change_memsize(e,t){var r;if(e!=endmem){if(!t&&heap_is_active()&&fatal_error("Cannot resize Glulx memory space while heap is active."),origendmem>e&&fatal_error("Cannot resize Glulx memory space smaller than it started."),255&e&&fatal_error("Can only resize Glulx memory space to a 256-byte boundary."),memmap.length=e,e>endmem)for(r=endmem;e>r;r++)memmap[r]=0;endmem=e}}function copy_protected_range(){if(protectstart>=protectend)return null;for(var e=protectend-protectstart,t={start:protectstart,end:protectend,len:e},r=memmap.slice(protectstart,protectend);e>r.length;)r.push(0);return t.mem=r,t}function paste_protected_range(e){if(e){var t,r,a=e.mem,n=e.start,s=e.end;for(s>endmem&&(s=endmem),t=0,r=n;s>r;t++,r++)memmap[r]=a[t]}}function perform_verify(){var e,t,r,a=game_image.length;if(256>a||0!=(255&a))return 1;if(a!=ByteRead4(game_image,12))return 1;for(r=ByteRead4(game_image,32),t=-r>>>0,e=0;a>e;e+=4)t=t+ByteRead4(game_image,e)>>>0;return t!=r?1:0}function quixe_get_signature(){return game_signature}function quixe_get_statistics(){var e={game_image_length:game_image.length,total_execution_time:total_execution_time,total_function_calls:total_function_calls,accel_function_calls:accel_function_calls,total_path_calls:total_path_calls,paths_cached:paths_cached,paths_compiled:paths_compiled,strings_cached:strings_cached,strings_compiled:strings_compiled};return e}function heap_clear(){heapstart=0,usedlist=[],freelist=[]}function heap_is_active(){return usedlist.length>0}function heap_get_start(){return heapstart}function HeapBlock(e,t){this.addr=e,this.size=t,this.end=e+t}function heap_binary_search(e,t){for(var r=0,a=e.length;a>r;){var n=r+a>>1;t>e[n].addr?r=n+1:a=n}return r}function heap_malloc(e){heap_is_active()||(heapstart=endmem);for(var t=0,r=freelist.length;r>t;t++){var a=freelist[t];if(a.size>=e){a.size>e?freelist[t]=new HeapBlock(a.addr+e,a.size-e):freelist.splice(t,1);var n=heap_binary_search(usedlist,a.addr);return usedlist.splice(n,0,new HeapBlock(a.addr,e)),a.addr}}var s=endmem,o=4294967040&e+255;return change_memsize(endmem+o,!0),o>e&&freelist.push(new HeapBlock(s+e,o-e)),usedlist.push(new HeapBlock(s,e)),s}function heap_free(e){var t=heap_binary_search(usedlist,e),r=usedlist[t];if(r&&r.addr==e||fatal_error("Tried to free non-existent block"),usedlist.splice(t,1),0==usedlist.length)return change_memsize(heapstart,!0),heap_clear(),void 0;t=heap_binary_search(freelist,e);var a=freelist[t];a&&a.addr==r.end&&(r=new HeapBlock(e,r.size+a.size),freelist.splice(t,1));var n=freelist[t-1];n&&n.end==r.addr&&(r=new HeapBlock(n.addr,n.size+r.size),freelist.splice(t-1,1),t-=1),freelist.splice(t,0,r)}function assert_heap_valid(){if(!heap_is_active())return 0!=heapstart&&fatal_error("Heap inconsistency: heapstart nonzero"),usedlist.length>0&&fatal_error("Heap inconsistency: usedlist nonempty"),freelist.length>0&&fatal_error("Heap inconsistency: usedlist nonempty"),void 0;0==heapstart&&fatal_error("Heap inconsistency: heapstart is zero");for(var e=heapstart,t=0,r=0;usedlist.length>t||freelist.length>r;){var a=usedlist[t],n=freelist[r];a&&a.addr==e?(e+=a.size,t++):n&&n.addr==e?(e+=n.size,r++):fatal_error("Heap inconsistency: no block at address "+e)}e!=endmem&&fatal_error("Heap inconsistency: overrun at end of heap")}function execute_loop(){var e,t,r,a,n;for(resumefuncop&&(store_operand_by_funcop(resumefuncop,resumevalue),resumefuncop=null,resumevalue=0),a=(new Date).getTime();!done_executing;){e=frame.vmfunc,t=e[iosysmode],r=t[pc],void 0===r&&(e.pathaddrs[pc]=!0,r=compile_path(e,pc,iosysmode),paths_compiled++,ramstart>pc&&(t[pc]=r,paths_cached++)),total_path_calls++;try{r()}catch(s){if(s!==ReturnedFromMain)throw s;done_executing=!0,vm_stopped=!0}}n=(new Date).getTime(),total_execution_time+=(n-a)/1e3,vm_stopped&&Glk.glk_exit(),Glk.update(),qlog("### done executing; path time = "+(n-a)+" ms")}var bytestring_table=Array(256),quotechar_table=Array(256),regexp_string_unsafe=/[^a-zA-Z0-9 .,;:?!=_+()-]/g,operandlist_table=null,funcop_cache={},opcode_table={0:function(){},16:function(e,t){e.code.push(t[2]+"(("+t[0]+")+("+t[1]+")) >>>0);")},17:function(e,t){e.code.push(t[2]+"(("+t[0]+")-("+t[1]+")) >>>0);")},18:function(e,t){var r=oputil_signify_operand(e,t[0]),a=oputil_signify_operand(e,t[1]);e.code.push(t[2]+"(("+r+")*("+a+")) >>>0);")},19:function(e,t){var r=oputil_signify_operand(e,t[0]),a=oputil_signify_operand(e,t[1]),n=alloc_holdvar(e);e.code.push(n+"=(("+r+")/("+a+"));"),e.code.push("if (!isFinite("+n+")) fatal_error('Division by zero.');"),e.code.push(t[2]+"("+n+">=0)?Math.floor("+n+"):(-Math.floor(-"+n+") >>>0));")},20:function(e,t){var r=oputil_signify_operand(e,t[0]),a=oputil_signify_operand(e,t[1]),n=alloc_holdvar(e);e.code.push(n+"=(("+r+")%("+a+"));"),e.code.push("if (!isFinite("+n+")) fatal_error('Modulo division by zero.');"),e.code.push(t[2]+n+" >>>0);")},21:function(e,t){e.code.push(t[1]+"(-("+t[0]+")) >>>0);")},24:function(e,t){e.code.push(t[2]+"(("+t[0]+")&("+t[1]+")) >>>0);")},25:function(e,t){e.code.push(t[2]+"(("+t[0]+")|("+t[1]+")) >>>0);")},26:function(e,t){e.code.push(t[2]+"(("+t[0]+")^("+t[1]+")) >>>0);")},27:function(e,t){e.code.push(t[1]+"(~("+t[0]+")) >>>0);")},28:function(e,t){if(quot_isconstant(t[1])){var r=Number(t[1]);32>r?e.code.push(t[2]+"(("+t[0]+")<<"+r+") >>>0);"):e.code.push(t[2]+"0);")}else e.code.push(t[2]+"("+t[1]+"<32) ? (("+t[0]+"<<"+t[1]+") >>>0) : 0);")},29:function(e,t){if(quot_isconstant(t[1])){var r=Number(t[1]);32>r?e.code.push(t[2]+"(("+t[0]+")>>"+r+") >>>0);"):e.code.push(t[2]+"(("+t[0]+")&0x80000000) ? 0xffffffff : 0);")}else e.code.push("if ("+t[0]+" & 0x80000000) {"),e.code.push(t[2]+"("+t[1]+"<32) ? (("+t[0]+">>"+t[1]+") >>>0) : 0xffffffff);"),e.code.push("} else {"),e.code.push(t[2]+"("+t[1]+"<32) ? (("+t[0]+">>"+t[1]+") >>>0) : 0);"),e.code.push("}")},30:function(e,t){if(quot_isconstant(t[1])){var r=Number(t[1]);32>r?e.code.push(t[2]+"("+t[0]+")>>>"+r+");"):e.code.push(t[2]+"0);")}else e.code.push(t[2]+"("+t[1]+"<32) ? ("+t[0]+">>>"+t[1]+") : 0);")},32:function(e,t){oputil_perform_jump(e,t[0],!0),e.path_ends=!0},260:function(e,t){if(quot_isconstant(t[0])){var r=Number(t[0]);e.code.push("pc = "+r+";"),e.vmfunc.pathaddrs[r]=!0}else e.code.push("pc = "+t[0]+";");oputil_unload_offstate(e),e.code.push("return;"),e.path_ends=!0},34:function(e,t){e.code.push("if (("+t[0]+")==0) {"),oputil_perform_jump(e,t[1]),e.code.push("}")},35:function(e,t){e.code.push("if (("+t[0]+")!=0) {"),oputil_perform_jump(e,t[1]),e.code.push("}")},36:function(e,t){e.code.push("if (("+t[0]+")==("+t[1]+")) {"),oputil_perform_jump(e,t[2]),e.code.push("}")},37:function(e,t){e.code.push("if (("+t[0]+")!=("+t[1]+")) {"),oputil_perform_jump(e,t[2]),e.code.push("}")},38:function(e,t){var r=oputil_signify_operand(e,t[0]),a=oputil_signify_operand(e,t[1]);e.code.push("if (("+r+")<("+a+")) {"),oputil_perform_jump(e,t[2]),e.code.push("}")},39:function(e,t){var r=oputil_signify_operand(e,t[0]),a=oputil_signify_operand(e,t[1]);e.code.push("if (("+r+")>=("+a+")) {"),oputil_perform_jump(e,t[2]),e.code.push("}")},40:function(e,t){var r=oputil_signify_operand(e,t[0]),a=oputil_signify_operand(e,t[1]);e.code.push("if (("+r+")>("+a+")) {"),oputil_perform_jump(e,t[2]),e.code.push("}")},41:function(e,t){var r=oputil_signify_operand(e,t[0]),a=oputil_signify_operand(e,t[1]);e.code.push("if (("+r+")<=("+a+")) {"),oputil_perform_jump(e,t[2]),e.code.push("}")},42:function(e,t){e.code.push("if (("+t[0]+")<("+t[1]+")) {"),oputil_perform_jump(e,t[2]),e.code.push("}")},43:function(e,t){e.code.push("if (("+t[0]+")>=("+t[1]+")) {"),oputil_perform_jump(e,t[2]),e.code.push("}")},44:function(e,t){e.code.push("if (("+t[0]+")>("+t[1]+")) {"),oputil_perform_jump(e,t[2]),e.code.push("}")},45:function(e,t){e.code.push("if (("+t[0]+")<=("+t[1]+")) {"),oputil_perform_jump(e,t[2]),e.code.push("}")},48:function(e,t){if(quot_isconstant(t[1])){var r,a=Number(t[1]);for(r=0;a>r;r++)if(e.offstack.length){var n=pop_offstack_holdvar(e);e.code.push("tempcallargs["+r+"]="+n+";")}else e.code.push("tempcallargs["+r+"]=frame.valstack.pop();");oputil_unload_offstate(e)}else e.varsused.ix=!0,oputil_unload_offstate(e),e.code.push("for (ix=0; ix<"+t[1]+"; ix++) { tempcallargs[ix]=frame.valstack.pop(); }");oputil_push_callstub(e,t[2]),e.code.push("enter_function("+t[0]+", "+t[1]+");"),e.code.push("return;"),e.path_ends=!0},52:function(e,t){if(quot_isconstant(t[1])){var r,a=Number(t[1]);for(r=0;a>r;r++)if(e.offstack.length){var n=pop_offstack_holdvar(e);e.code.push("tempcallargs["+r+"]="+n+";")}else e.code.push("tempcallargs["+r+"]=frame.valstack.pop();");oputil_unload_offstate(e)}else e.varsused.ix=!0,oputil_unload_offstate(e),e.code.push("for (ix=0; ix<"+t[1]+"; ix++) { tempcallargs[ix]=frame.valstack.pop(); }");e.code.push("leave_function();"),e.code.push("enter_function("+t[0]+", "+t[1]+");"),e.code.push("return;"),e.path_ends=!0},352:function(e,t){oputil_unload_offstate(e),oputil_push_callstub(e,t[1]),e.code.push("enter_function("+t[0]+", 0);"),e.code.push("return;"),e.path_ends=!0},353:function(e,t){oputil_unload_offstate(e),e.code.push("tempcallargs[0]=("+t[1]+");"),oputil_push_callstub(e,t[2]),e.code.push("enter_function("+t[0]+", 1);"),e.code.push("return;"),e.path_ends=!0},354:function(e,t){oputil_unload_offstate(e),e.code.push("tempcallargs[0]=("+t[1]+");"),e.code.push("tempcallargs[1]=("+t[2]+");"),oputil_push_callstub(e,t[3]),e.code.push("enter_function("+t[0]+", 2);"),e.code.push("return;"),e.path_ends=!0},355:function(e,t){oputil_unload_offstate(e),e.code.push("tempcallargs[0]=("+t[1]+");"),e.code.push("tempcallargs[1]=("+t[2]+");"),e.code.push("tempcallargs[2]=("+t[3]+");"),oputil_push_callstub(e,t[4]),e.code.push("enter_function("+t[0]+", 3);"),e.code.push("return;"),e.path_ends=!0},49:function(e,t){e.code.push("// quashing offstack for return: "+e.offstack.length),e.offstack.length=0,e.offloc.length=0,e.offlocdirty.length=0,e.code.push("leave_function();"),e.code.push("pop_callstub("+t[0]+");"),e.code.push("return;"),e.path_ends=!0},50:function(e,t){oputil_unload_offstate(e),oputil_push_callstub(e,t[0]),e.code.push("store_operand("+t[0]+",frame.framestart+frame.framelen+4*frame.valstack.length);"),oputil_perform_jump(e,t[1],!0),e.path_ends=!0},51:function(e,t){e.code.push("// quashing offstack for throw: "+e.offstack.length),e.offstack.length=0,e.offloc.length=0,e.offlocdirty.length=0,e.code.push("pop_stack_to("+t[1]+");"),e.code.push("pop_callstub("+t[0]+");"),e.code.push("return;"),e.path_ends=!0},64:function(e,t){oputil_store(e,t[1],t[0])},65:function(e,t){oputil_store(e,t[1],t[0])},66:function(e,t){oputil_store(e,t[1],t[0])},68:function(e,t){var r;quot_isconstant(t[0])?(r=Number(t[0]),r=32768&r?(4294901760|r)>>>0:65535&r,e.code.push(t[1]+r+");")):e.code.push(t[1]+"("+t[0]+" & 0x8000) ? (("+t[0]+" | 0xffff0000) >>> 0) : ("+t[0]+" & 0xffff));")},69:function(e,t){var r;quot_isconstant(t[0])?(r=Number(t[0]),r=128&r?(4294967040|r)>>>0:255&r,e.code.push(t[1]+r+");")):e.code.push(t[1]+"("+t[0]+" & 0x80) ? (("+t[0]+" | 0xffffff00) >>> 0) : ("+t[0]+" & 0xff));")},72:function(e,t){var r,a;if(quot_isconstant(t[1]))if(quot_isconstant(t[0]))a=Number(t[0])+4*Number(t[1]),r="Mem4("+(a>>>0)+")";else{var a=4*Number(t[1]);r=a?"Mem4(("+t[0]+"+"+a+") >>>0)":"Mem4("+t[0]+")"}else r="Mem4(("+t[0]+"+4*"+t[1]+") >>>0)";e.code.push(t[2]+r+");")},73:function(e,t){var r,a;if(quot_isconstant(t[1]))if(quot_isconstant(t[0]))a=Number(t[0])+2*Number(t[1]),r="Mem2("+(a>>>0)+")";else{var a=2*Number(t[1]);r=a?"Mem2(("+t[0]+"+"+a+") >>>0)":"Mem2("+t[0]+")"}else r="Mem2(("+t[0]+"+2*"+t[1]+") >>>0)";e.code.push(t[2]+r+");")},74:function(e,t){var r,a;if(quot_isconstant(t[1]))if(quot_isconstant(t[0]))a=Number(t[0])+Number(t[1]),r="Mem1("+(a>>>0)+")";else{var a=Number(t[1]);r=a?"Mem1(("+t[0]+"+"+a+") >>>0)":"Mem1("+t[0]+")"}else r="Mem1(("+t[0]+"+"+t[1]+") >>>0)";e.code.push(t[2]+r+");")},76:function(e,t){var r,a;if(quot_isconstant(t[1]))if(quot_isconstant(t[0]))a=Number(t[0])+4*Number(t[1]),r=(a>>>0)+",";else{var a=4*Number(t[1]);r=a?"("+t[0]+"+"+a+") >>>0"+",":t[0]+","}else r="("+t[0]+"+4*"+t[1]+") >>>0"+",";e.code.push("MemW4("+r+t[2]+")"+";")},77:function(e,t){var r,a;if(quot_isconstant(t[1]))if(quot_isconstant(t[0]))a=Number(t[0])+2*Number(t[1]),r=(a>>>0)+",";else{var a=2*Number(t[1]);r=a?"("+t[0]+"+"+a+") >>>0"+",":t[0]+","}else r="("+t[0]+"+2*"+t[1]+") >>>0"+",";e.code.push("MemW2("+r+t[2]+")"+";")},78:function(e,t){var r,a;if(quot_isconstant(t[1]))if(quot_isconstant(t[0]))a=Number(t[0])+Number(t[1]),r=(a>>>0)+",";else{var a=Number(t[1]);r=a?"("+t[0]+"+"+a+") >>>0"+",":t[0]+","}else r="("+t[0]+"+"+t[1]+") >>>0"+",";e.code.push("MemW1("+r+t[2]+")"+";")},75:function(e,t){if(quot_isconstant(t[1])){var r,a,n;n=4294967295&Number(t[1]),r=7&n,quot_isconstant(t[0])?(a=Number(t[0]),n>=0?a+=n>>3:a-=1+(-1-n>>3)):a=n>=0?7>=n?t[0]:t[0]+"+"+(n>>3):t[0]+"-"+(1+(-1-n>>3)),e.code.push(t[2]+"(Mem1("+a+") & "+(1<<r)+")?1:0);")}else{e.varsused.bitx=!0,e.varsused.addrx=!0;var s=oputil_signify_operand(e,t[1],!0);e.code.push("bitx = "+s+"&7;"),e.code.push("if ("+s+">=0) addrx = "+t[0]+" + ("+s+">>3);"),e.code.push("else addrx = "+t[0]+" - (1+((-1-("+s+"))>>3));"),e.code.push(t[2]+"(Mem1(addrx) & (1<<bitx))?1:0);")}},79:function(e,t){var r,a,n,s;if(quot_isconstant(t[1]))s=4294967295&Number(t[1]),r=7&s,quot_isconstant(t[0])?(a=Number(t[0]),s>=0?a+=s>>3:a-=1+(-1-s>>3)):a=s>=0?7>=s?t[0]:t[0]+"+"+(s>>3):t[0]+"-"+(1+(-1-s>>3)),n=1<<r;else{e.varsused.bitx=!0,e.varsused.addrx=!0;var o=oputil_signify_operand(e,t[1],!0);e.code.push("bitx = "+o+"&7;"),e.code.push("if ("+o+">=0) addrx = "+t[0]+" + ("+o+">>3);"),e.code.push("else addrx = "+t[0]+" - (1+((-1-("+o+"))>>3));"),a="addrx",n="(1<<bitx)"}quot_isconstant(t[2])?Number(t[2])?e.code.push("MemW1("+a+", Mem1("+a+") | "+n+");"):e.code.push("MemW1("+a+", Mem1("+a+") & ~("+n+"));"):(e.code.push("if ("+t[2]+") MemW1("+a+", Mem1("+a+") | "+n+");"),e.code.push("else MemW1("+a+", Mem1("+a+") & ~("+n+"));"))},80:function(e,t){var r,a=e.offstack.length;r=a?"frame.valstack.length+"+a:"frame.valstack.length",oputil_store(e,t[0],r)},81:function(e,t){var r;if(quot_isconstant(t[0])){var a=Number(t[0]);r=e.offstack.length>a?e.offstack[e.offstack.length-(a+1)]:"frame.valstack[frame.valstack.length-"+(a+1-e.offstack.length)+"]"}else oputil_unload_offstate(e),r="frame.valstack[frame.valstack.length-("+t[0]+"+1)]";oputil_store(e,t[1],r)},82:function(e){var t,r;2>e.offstack.length&&transfer_to_offstack(e,2),r=e.offstack.length,t=e.offstack[r-1],e.offstack[r-1]=e.offstack[r-2],e.offstack[r-2]=t},83:function(e,t){oputil_unload_offstate(e),e.varsused.ix=!0,e.varsused.pos=!0,e.varsused.roll=!0,e.varsused.vals1=!0;var r=oputil_signify_operand(e,t[0],!0),a=oputil_signify_operand(e,t[1],!0);e.code.push("if ("+r+" > 0) {"),e.code.push("if ("+a+" > 0) {"),e.code.push("vals1 = "+a+" % "+r+";"),e.code.push("} else {"),e.code.push("vals1 = "+r+" - (-("+a+")) % "+r+";"),e.code.push("}"),e.code.push("if (vals1) {"),e.code.push("pos = frame.valstack.length - "+r+";"),e.code.push("roll = frame.valstack.slice(frame.valstack.length-vals1, frame.valstack.length).concat(frame.valstack.slice(pos, frame.valstack.length-vals1));"),e.code.push("for (ix=0; ix<"+r+"; ix++) { frame.valstack[pos+ix] = roll[ix]; }"),e.code.push("roll = undefined;"),e.code.push("}"),e.code.push("}")},84:function(e,t){if(oputil_unload_offstate(e),quot_isconstant(t[0])){var r,a,n=Number(t[0]);for(r=0;n>r;r++)a=alloc_holdvar(e,!0),e.offstack.push(a),e.code.push(a+"=frame.valstack[frame.valstack.length-"+(n-r)+"];")}else e.varsused.ix=!0,e.varsused.jx=!0,e.code.push("jx = frame.valstack.length-("+t[0]+");"),e.code.push("for (ix=0; ix<"+t[0]+"; ix++) { frame.valstack.push(frame.valstack[jx+ix]); }")},256:function(e,t){var r="do_gestalt(("+t[0]+"),("+t[1]+"))";e.code.push(t[2]+r+");")},257:function(e,t){e.code.push("fatal_error('User debugtrap encountered.', "+t[0]+");")},258:function(e,t){e.code.push(t[0]+"endmem);")},259:function(e,t){e.code.push("change_memsize("+t[0]+",false);"),e.code.push(t[1]+"0);")},272:function(e,t){var r;if(quot_isconstant(t[0])){var a=4294967295&Number(t[0]);r=0==a?"(Math.floor(random_func() * 0x10000) | (Math.floor(random_func() * 0x10000) << 16)) >>>0":a>0?"Math.floor(random_func() * "+a+")":"-Math.floor(random_func() * "+-a+")"}else{var n=oputil_signify_operand(e,t[0],!0),s=alloc_holdvar(e);r=s,e.code.push("if ("+n+" > 0)"),e.code.push(s+" = Math.floor(random_func() * "+n+");"),e.code.push("else if ("+n+" < 0)"),e.code.push(s+" = -Math.floor(random_func() * -"+n+");"),e.code.push("else"),e.code.push(s+" = (Math.floor(random_func() * 0x10000) | (Math.floor(random_func() * 0x10000) << 16)) >>>0;")}e.code.push(t[1]+r+");")},273:function(e,t){e.code.push("set_random("+t[0]+");")},288:function(e){e.code.push("// quashing offstack for quit: "+e.offstack.length),e.offstack.length=0,e.offloc.length=0,e.offlocdirty.length=0,e.code.push("done_executing = true; vm_stopped = true;"),e.code.push("return;"),e.path_ends=!0},289:function(e,t){e.code.push(t[0]+"perform_verify());")},290:function(e){e.code.push("// quashing offstack for quit: "+e.offstack.length),e.offstack.length=0,e.offloc.length=0,e.offlocdirty.length=0,e.code.push("vm_restart();"),e.code.push("return;"),e.path_ends=!0},291:function(e,t){oputil_unload_offstate(e),e.varsused.ix=!0,oputil_push_callstub(e,t[1]),e.code.push("ix = vm_save("+t[0]+");"),e.code.push("pop_callstub(ix ? 0 : 1);"),e.code.push("return;"),e.path_ends=!0},292:function(e,t){oputil_unload_offstate(e),e.code.push("if (vm_restore("+t[0]+")) {"),e.code.push("pop_callstub((-1)>>>0);"),e.code.push("} else {"),oputil_store(e,t[1],"1"),oputil_unload_offstate(e),e.code.push("pc = "+e.cp+";"),e.code.push("}"),e.code.push("return;"),e.path_ends=!0},293:function(e,t){oputil_unload_offstate(e),oputil_push_callstub(e,t[0]),e.code.push("vm_saveundo();"),e.code.push("pop_callstub(0);"),e.code.push("return;"),e.path_ends=!0},294:function(e,t){oputil_unload_offstate(e),e.code.push("if (vm_restoreundo()) {"),e.code.push("pop_callstub((-1)>>>0);"),e.code.push("} else {"),oputil_store(e,t[0],"1"),oputil_unload_offstate(e),e.code.push("pc = "+e.cp+";"),e.code.push("}"),e.code.push("return;"),e.path_ends=!0},295:function(e,t){e.code.push("protectstart="+t[0]+";"),e.code.push("protectend=protectstart+("+t[1]+");"),e.code.push("if (protectstart==protectend) {"),e.code.push("  protectstart=0; protectend=0;"),e.code.push("}")},368:function(e,t){e.varsused.maddr=!0,e.varsused.mlen=!0,e.varsused.ix=!0,e.code.push("mlen="+t[0]+";"),e.code.push("maddr="+t[1]+";"),e.code.push("for (ix=0; ix<mlen; ix++, maddr++) MemW1(maddr, 0);")},369:function(e,t){e.varsused.msrc=!0,e.varsused.mdest=!0,e.varsused.mlen=!0,e.varsused.ix=!0,e.code.push("mlen="+t[0]+";"),e.code.push("msrc="+t[1]+";"),e.code.push("mdest="+t[2]+";"),e.code.push("if (mdest < msrc) {"),e.code.push("for (ix=0; ix<mlen; ix++, msrc++, mdest++) MemW1(mdest, Mem1(msrc));"),e.code.push("} else {"),e.code.push("msrc += (mlen-1); mdest += (mlen-1);"),e.code.push("for (ix=0; ix<mlen; ix++, msrc--, mdest--) MemW1(mdest, Mem1(msrc));"),e.code.push("}")},376:function(e,t){var r="heap_malloc("+t[0]+")";e.code.push(t[1]+r+");"),e.code.push("assert_heap_valid();")},377:function(e,t){e.code.push("heap_free("+t[0]+");"),e.code.push("assert_heap_valid();")},384:function(e,t){e.code.push("accel_address_map["+t[1]+"] = accel_func_map["+t[0]+"];")},385:function(e,t){e.code.push("if ("+t[0]+" < 9) {"),e.code.push("  accel_params["+t[0]+"] = "+t[1]+";"),e.code.push("}")},336:function(e,t){var r="linear_search(("+t[0]+"),("+t[1]+"),("+t[2]+"),("+t[3]+"),("+t[4]+"),("+t[5]+"),("+t[6]+"))";e.code.push(t[7]+r+");")},337:function(e,t){var r="binary_search(("+t[0]+"),("+t[1]+"),("+t[2]+"),("+t[3]+"),("+t[4]+"),("+t[5]+"),("+t[6]+"))";e.code.push(t[7]+r+");")},338:function(e,t){var r="linked_search(("+t[0]+"),("+t[1]+"),("+t[2]+"),("+t[3]+"),("+t[4]+"),("+t[5]+"))";e.code.push(t[6]+r+");")},112:function(e,t){switch(e.curiosys){case 2:if(quot_isconstant(t[0])){var r=255&Number(t[0]);e.code.push("Glk.glk_put_char("+r+");")}else e.code.push("Glk.glk_put_char(("+t[0]+")&0xff);");break;case 1:oputil_unload_offstate(e),e.code.push("tempcallargs[0]=(("+t[0]+")&0xff);"),oputil_push_callstub(e,"0,0"),e.code.push("enter_function(iosysrock, 1);"),e.code.push("return;"),e.path_ends=!0;break;case 0:e.code.push("// null streamchar "+t[0])}},113:function(e,t){switch(e.curiosys){case 2:var r=oputil_signify_operand(e,t[0]);if(quot_isconstant(t[0])){var a=Number(r).toString(10);e.code.push("Glk.glk_put_jstring("+QuoteEscapeString(a)+", true);")}else e.code.push("Glk.glk_put_jstring(("+r+").toString(10), true);");break;case 1:oputil_unload_offstate(e),e.code.push("stream_num("+e.cp+","+t[0]+", false, 0);"),e.code.push("return;"),e.path_ends=!0;break;case 0:e.code.push("// null streamnum "+t[0])}},114:function(e,t){oputil_unload_offstate(e),e.code.push("if (stream_string("+e.cp+","+t[0]+", 0, 0)) return;")},115:function(e,t){switch(e.curiosys){case 2:if(quot_isconstant(t[0])){var r=Number(t[0]);e.code.push("Glk.glk_put_char_uni("+r+");")}else e.code.push("Glk.glk_put_char_uni("+t[0]+");");break;case 1:oputil_unload_offstate(e),e.code.push("tempcallargs[0]=("+t[0]+");"),oputil_push_callstub(e,"0,0"),e.code.push("enter_function(iosysrock, 1);"),e.code.push("return;"),e.path_ends=!0;break;case 0:e.code.push("// null streamchar "+t[0])}},320:function(e,t){e.code.push(t[0]+"stringtable)")},321:function(e,t){e.code.push("set_string_table("+t[0]+");")},328:function(e,t){e.code.push(t[0]+"iosysmode)"),e.code.push(t[1]+"iosysrock)")},329:function(e,t){if(e.code.push("set_iosys("+t[0]+","+t[1]+");"),quot_isconstant(t[0])){var r=Number(t[0]);e.curiosys=r}else oputil_unload_offstate(e),e.code.push("pc = "+e.cp+";"),e.code.push("return;"),e.path_ends=!0},400:function(e,t){var r=oputil_signify_operand(e,t[0]);if(quot_isconstant(t[0])){var a=Number(r);e.code.push(t[1]+encode_float(a)+");")}else e.code.push(t[1]+"encode_float("+r+"));")},401:function(e,t){e.varsused.valf=!0,e.varsused.res=!0,e.code.push("valf = "+oputil_decode_float(e,t[0])+";"),e.code.push("if (!("+t[0]+" & 0x80000000)) {"),e.code.push("  if (isNaN(valf) || !isFinite(valf) || (valf > 0x7fffffff))"),e.code.push("    res = 0x7fffffff;"),e.code.push("  else"),e.code.push("    res = Math.floor(valf);"),e.code.push("} else {"),e.code.push("  if (isNaN(valf) || !isFinite(valf) || (valf < -0x80000000))"),e.code.push("    res = -0x80000000;"),e.code.push("  else"),e.code.push("    res = Math.ceil(valf);"),e.code.push("}"),e.code.push(t[1]+"res>>>0);")},402:function(e,t){e.varsused.valf=!0,e.varsused.res=!0,e.code.push("valf = "+oputil_decode_float(e,t[0])+";"),e.code.push("if (!("+t[0]+" & 0x80000000)) {"),e.code.push("  if (isNaN(valf) || !isFinite(valf))"),e.code.push("    res = 0x7fffffff;"),e.code.push("  else"),e.code.push("    res = Math.round(valf);"),e.code.push("  if (res > 0x7fffffff) res = 0x7fffffff;"),e.code.push("} else {"),e.code.push("  if (isNaN(valf) || !isFinite(valf))"),e.code.push("    res = -0x80000000;"),e.code.push("  else"),e.code.push("    res = Math.round(valf);"),e.code.push("  if (res < -0x80000000) res = -0x80000000;"),e.code.push("}"),e.code.push(t[1]+"res>>>0);")},408:function(e,t){var r=oputil_decode_float(e,t[0]);e.code.push(t[1]+"encode_float(Math.ceil("+r+")));")},409:function(e,t){var r=oputil_decode_float(e,t[0]);e.code.push(t[1]+"encode_float(Math.floor("+r+")));")},416:function(e,t){var r=oputil_decode_float(e,t[0]),a=oputil_decode_float(e,t[1]);e.code.push(t[2]+"encode_float("+r+" + "+a+"));")},417:function(e,t){var r=oputil_decode_float(e,t[0]),a=oputil_decode_float(e,t[1]);e.code.push(t[2]+"encode_float("+r+" - "+a+"));")},418:function(e,t){var r=oputil_decode_float(e,t[0]),a=oputil_decode_float(e,t[1]);e.code.push(t[2]+"encode_float("+r+" * "+a+"));")},419:function(e,t){var r=oputil_decode_float(e,t[0]),a=oputil_decode_float(e,t[1]);e.code.push(t[2]+"encode_float("+r+" / "+a+"));")},420:function(e,t){var r=oputil_decode_float(e,t[0],!0),a=oputil_decode_float(e,t[1],!0);e.varsused.modv=!0,e.varsused.quov=!0,e.code.push("modv=("+r+" % "+a+");"),e.code.push("quov=encode_float(("+r+" - modv) / "+a+");"),e.code.push("if (quov == 0x0 || quov == 0x80000000) {"),e.code.push("  quov = (("+t[0]+" ^ "+t[1]+") & 0x80000000) >>>0;"),e.code.push("}"),e.code.push(t[2]+"encode_float(modv));"),e.code.push(t[3]+"quov);")
},424:function(e,t){var r=oputil_decode_float(e,t[0]);e.code.push(t[1]+"encode_float(Math.sqrt("+r+")));")},425:function(e,t){var r=oputil_decode_float(e,t[0]);e.code.push(t[1]+"encode_float(Math.exp("+r+")));")},426:function(e,t){var r=oputil_decode_float(e,t[0]);e.code.push(t[1]+"encode_float(Math.log("+r+")));")},427:function(e,t){e.varsused.valf=!0;var r=oputil_decode_float(e,t[0],!0),a=oputil_decode_float(e,t[1],!0);e.code.push("if ("+t[0]+" == 0x3f800000) {"),e.code.push("  valf = 0x3f800000;"),e.code.push("} else if ("+t[0]+" == 0xbf800000 && ("+t[1]+" == 0xff800000 || "+t[1]+" == 0x7f800000)) {"),e.code.push("  valf = 0x3f800000;"),e.code.push("} else {"),e.code.push("  valf=encode_float(Math.pow("+r+", "+a+"));"),e.code.push("}"),e.code.push(t[2]+"valf);")},432:function(e,t){var r=oputil_decode_float(e,t[0]);e.code.push(t[1]+"encode_float(Math.sin("+r+")));")},433:function(e,t){var r=oputil_decode_float(e,t[0]);e.code.push(t[1]+"encode_float(Math.cos("+r+")));")},434:function(e,t){var r=oputil_decode_float(e,t[0]);e.code.push(t[1]+"encode_float(Math.tan("+r+")));")},435:function(e,t){var r=oputil_decode_float(e,t[0]);e.code.push(t[1]+"encode_float(Math.asin("+r+")));")},436:function(e,t){var r=oputil_decode_float(e,t[0]);e.code.push(t[1]+"encode_float(Math.acos("+r+")));")},437:function(e,t){var r=oputil_decode_float(e,t[0]);e.code.push(t[1]+"encode_float(Math.atan("+r+")));")},438:function(e,t){var r=oputil_decode_float(e,t[0]),a=oputil_decode_float(e,t[1]);e.code.push(t[2]+"encode_float(Math.atan2("+r+", "+a+")));")},448:function(e,t){var r,a,n,s;e.varsused.fequal=!0,e.varsused.fdiff=!0,e.code.push("if (("+t[2]+" & 0x7f800000) == 0x7f800000 && ("+t[2]+" & 0x007fffff) != 0) {"),e.code.push("  fequal = 0;"),e.code.push("} else if (("+t[0]+" == 0xff800000 || "+t[0]+" == 0x7f800000) && ("+t[1]+" == 0xff800000 || "+t[1]+" == 0x7f800000)) {"),e.code.push("  fequal = ("+t[0]+" == "+t[1]+");"),e.code.push("} else {"),quot_isconstant(t[2])?(r=Number(t[2]),s=""+decode_float(2147483647&r)):(r="decode_float(("+t[2]+") & 0x7fffffff)",s=alloc_holdvar(e),e.code.push(s+"="+r+";")),a=oputil_decode_float(e,t[0]),n=oputil_decode_float(e,t[1]),e.code.push("  fdiff = "+n+" - "+a+";"),e.code.push("  fequal = (fdiff <= "+s+" && fdiff >= -("+s+"));"),e.code.push("}"),e.code.push("if (fequal) {"),oputil_perform_jump(e,t[3]),e.code.push("}")},449:function(e,t){var r,a,n,s;e.varsused.fequal=!0,e.varsused.fdiff=!0,e.code.push("if (("+t[2]+" & 0x7f800000) == 0x7f800000 && ("+t[2]+" & 0x007fffff) != 0) {"),e.code.push("  fequal = 0;"),e.code.push("} else if (("+t[0]+" == 0xff800000 || "+t[0]+" == 0x7f800000) && ("+t[1]+" == 0xff800000 || "+t[1]+" == 0x7f800000)) {"),e.code.push("  fequal = ("+t[0]+" == "+t[1]+");"),e.code.push("} else {"),quot_isconstant(t[2])?(r=Number(t[2]),s=""+decode_float(2147483647&r)):(r="decode_float(("+t[2]+") & 0x7fffffff)",s=alloc_holdvar(e),e.code.push(s+"="+r+";")),a=oputil_decode_float(e,t[0]),n=oputil_decode_float(e,t[1]),e.code.push("  fdiff = "+n+" - "+a+";"),e.code.push("  fequal = (fdiff <= "+s+" && fdiff >= -("+s+"));"),e.code.push("}"),e.code.push("if (!fequal) {"),oputil_perform_jump(e,t[3]),e.code.push("}")},450:function(e,t){valf0=oputil_decode_float(e,t[0]),valf1=oputil_decode_float(e,t[1]),e.code.push("if ("+valf0+" < "+valf1+") {"),oputil_perform_jump(e,t[2]),e.code.push("}")},451:function(e,t){valf0=oputil_decode_float(e,t[0]),valf1=oputil_decode_float(e,t[1]),e.code.push("if ("+valf0+" <= "+valf1+") {"),oputil_perform_jump(e,t[2]),e.code.push("}")},452:function(e,t){valf0=oputil_decode_float(e,t[0]),valf1=oputil_decode_float(e,t[1]),e.code.push("if ("+valf0+" > "+valf1+") {"),oputil_perform_jump(e,t[2]),e.code.push("}")},453:function(e,t){valf0=oputil_decode_float(e,t[0]),valf1=oputil_decode_float(e,t[1]),e.code.push("if ("+valf0+" >= "+valf1+") {"),oputil_perform_jump(e,t[2]),e.code.push("}")},456:function(e,t){e.code.push("if (("+t[0]+" & 0x7f800000) == 0x7f800000 && ("+t[0]+" & 0x007fffff) != 0) {"),oputil_perform_jump(e,t[1]),e.code.push("}")},457:function(e,t){e.code.push("if ("+t[0]+" == 0xff800000 || "+t[0]+" == 0x7f800000) {"),oputil_perform_jump(e,t[1]),e.code.push("}")},304:function(e,t){var r;if(r=quot_isconstant(t[0])?Glk.call_may_not_return(Number(t[0])):!0,e.code.push("tempglkargs.length = "+t[1]+";"),quot_isconstant(t[1])){var a,n=Number(t[1]);for(a=0;n>a;a++)if(e.offstack.length){var s=pop_offstack_holdvar(e);e.code.push("tempglkargs["+a+"]="+s+";")}else e.code.push("tempglkargs["+a+"]=frame.valstack.pop();");oputil_unload_offstate(e)}else e.varsused.ix=!0,oputil_unload_offstate(e),e.code.push("for (ix=0; ix<"+t[1]+"; ix++) { tempglkargs[ix]=frame.valstack.pop(); }");e.varsused.glkret=!0,e.code.push("glkret = GiDispa.get_function("+t[0]+")(tempglkargs);"),r&&(e.code.push("if (glkret === Glk.DidNotReturn) {"),e.code.push("  resumefuncop = "+oputil_record_funcop(t[2])+";"),e.code.push("  resumevalue = 0;"),e.code.push("  pc = "+e.cp+";"),e.code.push("  done_executing = true;"),e.code.push("  return;"),e.code.push("}")),oputil_store(e,t[2],"glkret")}},ReturnedFromMain={dummy:"The top-level function has returned."},srand_table=void 0,srand_index1,srand_index2,accel_address_map={},accel_params=[0,0,0,0,0,0,0,0,0],accel_func_map={1:function func_1_z__region(e,t){if(1>e)return 0;var r=t[0];if(36>r)return 0;if(r>=endmem)return 0;var a=Mem1(r);return a>=224?3:a>=192?2:a>=112&&127>=a&&r>=ramstart?1:0},2:function func_2_cp__tab(e,t){var r=e>0?t[0]:0,a=e>1?t[1]:0;if(1!=accel_func_map[1](e,t))return Glk.glk_put_jstring('\n[** Programming error: tried to find the "." of (something) **]\n'),0;var n=Mem4(r+16);if(!n)return 0;var s=Mem4(n);return n+=4,binary_search(a,2,n,10,s,0,0)},3:function func_3_ra__pr(e,t){var r=e>0?t[0]:0,a=e>1?t[1]:0,n=accel_helper_get_prop(r,a);return 0==n?0:Mem4(n+4)},4:function func_4_rl__pr(e,t){var r=e>0?t[0]:0,a=e>1?t[1]:0,n=accel_helper_get_prop(r,a);return 0==n?0:4*Mem2(n+2)},5:function func_5_oc__cl(e,t){var r,a,n,s,o,i=e>0?t[0]:0,c=e>1?t[1]:0;if(r=accel_func_map[1](e,t),3==r)return c==accel_params[5]?1:0;if(2==r)return c==accel_params[4]?1:0;if(1!=r)return 0;if(c==accel_params[2])return accel_helper_obj_in_class(i)?1:i==accel_params[2]?1:i==accel_params[5]?1:i==accel_params[4]?1:i==accel_params[3]?1:0;if(c==accel_params[3])return accel_helper_obj_in_class(i)?0:i==accel_params[2]?0:i==accel_params[5]?0:i==accel_params[4]?0:i==accel_params[3]?0:1;if(c==accel_params[5]||c==accel_params[4])return 0;if(!accel_helper_obj_in_class(c))return Glk.glk_put_jstring("\n[** Programming error: tried to apply 'ofclass' with non-class **]\n"),0;if(a=accel_helper_get_prop(i,2),0==a)return 0;if(n=Mem4(a+4),0==n)return 0;for(s=Mem2(a+2),o=0;s>o;o++)if(Mem4(n+4*o)==c)return 1;return 0},6:function func_6_rv__pr(e,t){var r,a=e>1?t[1]:0;return r=accel_func_map[3](e,t),0==r?a>0&&accel_params[1]>a?Mem4(accel_params[8]+4*a):(Glk.glk_put_jstring("\n[** Programming error: tried to read (something) **]\n"),0):Mem4(r)},7:function func_7_op__pr(e,t){var r=e>0?t[0]:0,a=e>1?t[1]:0,n=accel_params[1],s=accel_func_map[1](e,t);return 3==s?a==n+6?1:a==n+7?1:0:2==s?a==n+5?1:0:1!=s?0:a>=n&&n+8>a&&accel_helper_obj_in_class(r)?1:accel_func_map[3](e,t)?1:0}},accel_helper_temp_args=[0,0],tempsearchkey=[],game_image=null,game_signature=null,opt_rethrow_exceptions=null,memmap,stack,frame,vm_started=!1,vm_stopped=!1,tempcallargs,tempglkargs,done_executing,vmfunc_table,vmtextenv_table,decoding_tree,vmstring_table,random_func,ramstart,endgamefile,origendmem,stacksize,startfuncaddr,origstringtable,checksum,pc,stringtable,endmem,protectstart,protectend,iosysmode,iosysrock,undostack,resumefuncop,resumevalue,heapstart,usedlist,freelist,total_execution_time=0,total_function_calls=0,accel_function_calls=0,total_path_calls=0,paths_cached=0,paths_compiled=0,strings_cached=0,strings_compiled=0;return{version:"1.1.1",prepare:quixe_prepare,init:quixe_init,resume:quixe_resume,get_signature:quixe_get_signature,get_statistics:quixe_get_statistics,ReadByte:ReadArgByte,WriteByte:WriteArgByte,ReadWord:ReadArgWord,WriteWord:WriteArgWord,ReadStructField:ReadStructField,WriteStructField:WriteStructField,SetResumeStore:SetResumeStore}}(),GiDispa=function(){function set_vm(e){VM=e}function FuncSpec(e,t,r){this.id=e,this.name=t,this.proto=r}function Prototype(e,t){this.args=e,this.retarg=t}function ArgString(){this.macro="Byte",this.refsize=1}function ArgUnicode(){this.macro="Word",this.refsize=4}function ArgChar(e){this.signed=e,this.macro="Byte",this.refsize=1,this.literal=e?"arg_char_signed":"arg_char_unsigned"}function ArgInt(e){this.signed=e,this.macro="Word",this.refsize=4,this.literal=e?"arg_int_signed":"arg_int_unsigned"}function ArgClass(e){this.name=e,this.macro="Word",this.refsize=4}function ArgStruct(e){this.form=e}function ArgRef(e,t,r,a){this.arg=e,this.passin=t,this.passout=r,this.nonnull=a}function ArgArray(e,t,r,a,n){this.arg=e,this.retained=t,this.passin=r,this.passout=a,this.nonnull=n}function convert_arg(e,t,r){return e instanceof ArgInt?t?e.signed?r+" & 0xFFFFFFFF":r:"0":e instanceof ArgChar?t?e.signed?"cast_signed_char("+r+")":r+" & 0xFF":"0":e instanceof ArgClass?t?'class_obj_from_id("'+e.name+'", '+r+")":"null":"???"}function unconvert_arg(e,t){return e instanceof ArgInt?t+" >>> 0":e instanceof ArgChar?e.signed?"uncast_signed_char("+t+")":t+" & 0xFF":e instanceof ArgClass?'class_obj_to_id("'+e.name+'", '+t+")":"???"}function cast_signed_char(e){return e=255&e,128&e&&(e-=256),e}function uncast_signed_char(e){return e=255&e,128&e&&(e+=4294967040),e}function class_obj_to_id(e,t){return t?t.disprock:0}function class_obj_from_id(e,t){return 0==t?null:class_map[e][t]}function build_function(func){var ix,jx,form,retarg,argpos,argjoin,subargs,arg,refarg,tmpvar,val,retval,ls,mayblock,out=[],locals={},arraycount=0;for(out.push("// no local vars"),out.push("// "+func.id+": "+func.name),form=func.proto,retarg=null,form.retarg&&(retarg=form.retarg.arg),mayblock=Glk.call_may_not_return(func.id),argpos=0,argjoin=[],ix=0;form.args.length>ix;ix++)if(arg=form.args[ix],tmpvar="glka"+ix,argjoin.push(tmpvar),locals[tmpvar]=!0,arg instanceof ArgInt||arg instanceof ArgChar||arg instanceof ArgClass)val=convert_arg(arg,!0,"callargs["+argpos+"]"),out.push(tmpvar+" = "+val+";"),argpos+=1;else if(arg instanceof ArgRef){if(refarg=arg.arg,out.push("if (callargs["+argpos+"] == 0) {"),arg.nonnull?out.push('  throw("glk '+func.name+': null argument");'):out.push("  "+tmpvar+" = null;"),out.push("} else {"),refarg instanceof ArgInt||refarg instanceof ArgChar||refarg instanceof ArgClass)out.push("  "+tmpvar+" = new Glk.RefBox();"),val=convert_arg(refarg,arg.passin,"VM.ReadWord(callargs["+argpos+"])"),out.push("  "+tmpvar+".set_value("+val+");");else{if(!(refarg instanceof ArgStruct))throw"buildfunc: unsupported refarg type: "+func.name;for(subargs=refarg.form.args,out.push("  "+tmpvar+" = new Glk.RefStruct("+subargs.length+");"),jx=0;subargs.length>jx;jx++)val=convert_arg(subargs[jx],arg.passin,"VM.ReadStructField(callargs["+argpos+"], "+jx+")"),out.push("  "+tmpvar+".push_field("+val+");")}out.push("}"),argpos+=1}else if(arg instanceof ArgArray)locals.glklen=!0,refarg=arg.arg,out.push("if (callargs["+argpos+"] == 0) {"),arg.nonnull?out.push('  throw("glk '+func.name+': null argument");'):out.push("  "+tmpvar+" = null;"),out.push("} else {"),out.push("  glklen = callargs["+(argpos+1)+"];"),out.push("  "+tmpvar+" = Array(glklen);"),arg.passin&&(locals.ix=!0,locals.jx=!0,out.push("  for (ix=0, jx=callargs["+argpos+"]; ix<glklen; ix++, jx+="+refarg.refsize+") {"),val=convert_arg(refarg,!0,"VM.Read"+refarg.macro+"(jx)"),out.push("    "+tmpvar+"[ix] = "+val+";"),out.push("  }")),arg.retained&&(0==arraycount&&out.push("  temp_arg_arrays.length = 0;"),arraycount+=1,out.push("  make_arg_array("+tmpvar+", callargs["+argpos+"], glklen, "+refarg.literal+");")),out.push("}"),argpos+=2;else{if(!(arg instanceof ArgString||arg instanceof ArgUnicode))throw"buildfunc: unsupported arg type: "+func.name;locals.ix=!0,locals.jx=!0;var confunc,checkbyte;arg instanceof ArgString?(checkbyte="0xE0",confunc="byte_array_to_string"):(checkbyte="0xE2",confunc="uni_array_to_string"),out.push(tmpvar+" = Array();"),out.push("jx = callargs["+argpos+"];"),out.push("if (VM.ReadByte(jx) != "+checkbyte+') throw("glk '+func.name+': string argument must be unencoded");'),out.push("for (jx+="+arg.refsize+"; true; jx+="+arg.refsize+") {"),out.push("  ix = VM.Read"+arg.macro+"(jx);"),out.push("  if (ix == 0) break;"),out.push("  "+tmpvar+".push(ix);"),out.push("}"),out.push(tmpvar+" = Glk."+confunc+"("+tmpvar+");"),argpos+=1}for(out.push("if (callargs.length != "+argpos+') throw "glk '+func.name+': wrong number of arguments";'),retarg||mayblock?(locals.glkret=!0,retval="glkret = "):retval="",out.push(retval+"Glk.glk_"+func.name+"("+argjoin.join(", ")+");"),mayblock&&(out.push("if (glkret === Glk.DidNotReturn) {"),out.push("  set_blocked_selector("+func.id+", callargs);"),out.push("  return glkret;"),out.push("}")),argpos=0,ix=0;form.args.length>ix;ix++)if(arg=form.args[ix],tmpvar="glka"+ix,arg instanceof ArgInt||arg instanceof ArgChar||arg instanceof ArgClass)argpos+=1;else if(arg instanceof ArgRef){if(refarg=arg.arg,arg.passout){if(out.push("if ("+tmpvar+") {"),refarg instanceof ArgInt||refarg instanceof ArgChar||refarg instanceof ArgClass)val=unconvert_arg(refarg,tmpvar+".get_value()"),out.push("  VM.WriteWord(callargs["+argpos+"], "+val+");");else{if(!(refarg instanceof ArgStruct))throw"buildfunc: unsupported refarg type: "+func.name;for(subargs=refarg.form.args,jx=0;subargs.length>jx;jx++)val=unconvert_arg(subargs[jx],tmpvar+".get_field("+jx+")"),out.push("  VM.WriteStructField(callargs["+argpos+"], "+jx+", "+val+");")}out.push("}")}argpos+=1}else if(arg instanceof ArgArray)refarg=arg.arg,arg.passout&&!arg.retained&&(out.push("if ("+tmpvar+") {"),locals.ix=!0,locals.jx=!0,out.push("  for (ix=0, jx=callargs["+argpos+"]; ix<glklen; ix++, jx+="+refarg.refsize+") {"),val=unconvert_arg(refarg,tmpvar+"[ix]"),out.push("    VM.Write"+refarg.macro+"(jx, "+val+")"),out.push("  }"),out.push("}")),argpos+=2;else{if(!(arg instanceof ArgString||arg instanceof ArgUnicode))throw"buildfunc: unsupported arg type: "+func.name;argpos+=1}0!=arraycount&&out.push("temp_arg_arrays.length = 0;"),retarg?(val=unconvert_arg(retarg,"glkret"),out.push("return "+val+";")):out.push("return 0;"),ls=[];for(val in locals)ls.push(val);return ls.length&&(out[0]="var "+ls.join(", ")+";"),val=out.join("\n"),eval("function _func(callargs) {\n"+val+"\n}"),_func}function get_function(e){var t,r=function_map[e];if(void 0===r){if(t=proto_map[e],void 0===t)throw"dispatch: unknown Glk function: "+e;r=build_function(t),function_map[e]=r}return r}function set_blocked_selector(e,t){blocked_selector=e,blocked_callargs=t.slice(0)}function prepare_resume(e){192==blocked_selector?0!=blocked_callargs[0]&&(VM.WriteStructField(blocked_callargs[0],0,e.get_field(0)>>>0),VM.WriteStructField(blocked_callargs[0],1,class_obj_to_id("window",e.get_field(1))),VM.WriteStructField(blocked_callargs[0],2,e.get_field(2)>>>0),VM.WriteStructField(blocked_callargs[0],3,e.get_field(3)>>>0)):98==blocked_selector&&VM.SetResumeStore(class_obj_to_id("fileref",e)),blocked_selector=null,blocked_callargs=null}function make_arg_array(e,t,r,a){var n;e&&(n={arr:e,addr:t,len:r,arg:a},temp_arg_arrays.push(n))}function retain_array(e){var t,r;if(e){for(r=void 0,t=0;temp_arg_arrays.length>t;t++)if(temp_arg_arrays[t].arr===e){r=temp_arg_arrays[t];break}if(void 0===r)throw"retain_array: array is not an argument";for(t=0;void 0!==retained_arrays[t];t++);retained_arrays[t]=r}}function unretain_array(e){var t,r,a;if(e){for(a=void 0,t=0;retained_arrays.length>t;t++)if(void 0!==retained_arrays[t]&&retained_arrays[t].arr===e){a=retained_arrays[t],delete retained_arrays[t];break}if(void 0===a)throw"unretain_array: array was never retained";if(a.arg instanceof ArgInt)for(t=0,r=a.addr;a.len>t;t++,r+=4)VM.WriteWord(r,a.arr[t]>>>0);else{if(!(a.arg instanceof ArgChar))throw"unretain_array: unsupported refarg type";if(a.arg.signed)for(t=0,r=a.addr;a.len>t;t++,r++)VM.WriteByte(r,uncast_signed_char(a.arr[t]));else for(t=0,r=a.addr;a.len>t;t++,r++)VM.WriteByte(r,255&a.arr[t])}}}function class_register(e,t){if(t.disprock)throw"class_register: object is already registered";t.disprock=last_used_id,last_used_id++,class_map[e][t.disprock]=t}function class_unregister(e,t){if(!t.disprock||void 0===class_map[e][t.disprock])throw"class_unregister: object is not registered";delete class_map[e][t.disprock],t.disprock=void 0}function init_module(){var e,t;last_used_id=1+Math.round(1e3*Math.random());for(e in class_defs)t=class_defs[e],class_map[t]={}}var VM=null,class_defs={0:"window",1:"stream",2:"fileref",3:"schannel"},arg_int_unsigned=new ArgInt(!1),arg_int_signed=new ArgInt(!0),arg_char_unsigned=new ArgChar(!1),arg_char_native=new ArgChar(null),arg_char_signed=new ArgChar(!0),arg_class_window=new ArgClass("window"),arg_class_stream=new ArgClass("stream"),arg_class_fileref=new ArgClass("fileref"),arg_class_schannel=new ArgClass("schannel"),proto_map={1:new FuncSpec(1,"exit",new Prototype([],null)),3:new FuncSpec(3,"tick",new Prototype([],null)),4:new FuncSpec(4,"gestalt",new Prototype([arg_int_unsigned,arg_int_unsigned],new ArgRef(arg_int_unsigned,!1,!0,!0))),5:new FuncSpec(5,"gestalt_ext",new Prototype([arg_int_unsigned,arg_int_unsigned,new ArgArray(arg_int_unsigned,!1,!0,!0,!1)],new ArgRef(arg_int_unsigned,!1,!0,!0))),32:new FuncSpec(32,"window_iterate",new Prototype([arg_class_window,new ArgRef(arg_int_unsigned,!1,!0,!1)],new ArgRef(arg_class_window,!1,!0,!0))),33:new FuncSpec(33,"window_get_rock",new Prototype([arg_class_window],new ArgRef(arg_int_unsigned,!1,!0,!0))),34:new FuncSpec(34,"window_get_root",new Prototype([],new ArgRef(arg_class_window,!1,!0,!0))),35:new FuncSpec(35,"window_open",new Prototype([arg_class_window,arg_int_unsigned,arg_int_unsigned,arg_int_unsigned,arg_int_unsigned],new ArgRef(arg_class_window,!1,!0,!0))),36:new FuncSpec(36,"window_close",new Prototype([arg_class_window,new ArgRef(new ArgStruct(new Prototype([arg_int_unsigned,arg_int_unsigned],null)),!1,!0,!1)],null)),37:new FuncSpec(37,"window_get_size",new Prototype([arg_class_window,new ArgRef(arg_int_unsigned,!1,!0,!1),new ArgRef(arg_int_unsigned,!1,!0,!1)],null)),38:new FuncSpec(38,"window_set_arrangement",new Prototype([arg_class_window,arg_int_unsigned,arg_int_unsigned,arg_class_window],null)),39:new FuncSpec(39,"window_get_arrangement",new Prototype([arg_class_window,new ArgRef(arg_int_unsigned,!1,!0,!1),new ArgRef(arg_int_unsigned,!1,!0,!1),new ArgRef(arg_class_window,!1,!0,!1)],null)),40:new FuncSpec(40,"window_get_type",new Prototype([arg_class_window],new ArgRef(arg_int_unsigned,!1,!0,!0))),41:new FuncSpec(41,"window_get_parent",new Prototype([arg_class_window],new ArgRef(arg_class_window,!1,!0,!0))),42:new FuncSpec(42,"window_clear",new Prototype([arg_class_window],null)),43:new FuncSpec(43,"window_move_cursor",new Prototype([arg_class_window,arg_int_unsigned,arg_int_unsigned],null)),44:new FuncSpec(44,"window_get_stream",new Prototype([arg_class_window],new ArgRef(arg_class_stream,!1,!0,!0))),45:new FuncSpec(45,"window_set_echo_stream",new Prototype([arg_class_window,arg_class_stream],null)),46:new FuncSpec(46,"window_get_echo_stream",new Prototype([arg_class_window],new ArgRef(arg_class_stream,!1,!0,!0))),47:new FuncSpec(47,"set_window",new Prototype([arg_class_window],null)),48:new FuncSpec(48,"window_get_sibling",new Prototype([arg_class_window],new ArgRef(arg_class_window,!1,!0,!0))),64:new FuncSpec(64,"stream_iterate",new Prototype([arg_class_stream,new ArgRef(arg_int_unsigned,!1,!0,!1)],new ArgRef(arg_class_stream,!1,!0,!0))),65:new FuncSpec(65,"stream_get_rock",new Prototype([arg_class_stream],new ArgRef(arg_int_unsigned,!1,!0,!0))),66:new FuncSpec(66,"stream_open_file",new Prototype([arg_class_fileref,arg_int_unsigned,arg_int_unsigned],new ArgRef(arg_class_stream,!1,!0,!0))),67:new FuncSpec(67,"stream_open_memory",new Prototype([new ArgArray(arg_char_native,!0,!0,!0,!0),arg_int_unsigned,arg_int_unsigned],new ArgRef(arg_class_stream,!1,!0,!0))),68:new FuncSpec(68,"stream_close",new Prototype([arg_class_stream,new ArgRef(new ArgStruct(new Prototype([arg_int_unsigned,arg_int_unsigned],null)),!1,!0,!1)],null)),69:new FuncSpec(69,"stream_set_position",new Prototype([arg_class_stream,arg_int_signed,arg_int_unsigned],null)),70:new FuncSpec(70,"stream_get_position",new Prototype([arg_class_stream],new ArgRef(arg_int_unsigned,!1,!0,!0))),71:new FuncSpec(71,"stream_set_current",new Prototype([arg_class_stream],null)),72:new FuncSpec(72,"stream_get_current",new Prototype([],new ArgRef(arg_class_stream,!1,!0,!0))),96:new FuncSpec(96,"fileref_create_temp",new Prototype([arg_int_unsigned,arg_int_unsigned],new ArgRef(arg_class_fileref,!1,!0,!0))),97:new FuncSpec(97,"fileref_create_by_name",new Prototype([arg_int_unsigned,new ArgString,arg_int_unsigned],new ArgRef(arg_class_fileref,!1,!0,!0))),98:new FuncSpec(98,"fileref_create_by_prompt",new Prototype([arg_int_unsigned,arg_int_unsigned,arg_int_unsigned],new ArgRef(arg_class_fileref,!1,!0,!0))),99:new FuncSpec(99,"fileref_destroy",new Prototype([arg_class_fileref],null)),100:new FuncSpec(100,"fileref_iterate",new Prototype([arg_class_fileref,new ArgRef(arg_int_unsigned,!1,!0,!1)],new ArgRef(arg_class_fileref,!1,!0,!0))),101:new FuncSpec(101,"fileref_get_rock",new Prototype([arg_class_fileref],new ArgRef(arg_int_unsigned,!1,!0,!0))),102:new FuncSpec(102,"fileref_delete_file",new Prototype([arg_class_fileref],null)),103:new FuncSpec(103,"fileref_does_file_exist",new Prototype([arg_class_fileref],new ArgRef(arg_int_unsigned,!1,!0,!0))),104:new FuncSpec(104,"fileref_create_from_fileref",new Prototype([arg_int_unsigned,arg_class_fileref,arg_int_unsigned],new ArgRef(arg_class_fileref,!1,!0,!0))),128:new FuncSpec(128,"put_char",new Prototype([arg_char_unsigned],null)),129:new FuncSpec(129,"put_char_stream",new Prototype([arg_class_stream,arg_char_unsigned],null)),130:new FuncSpec(130,"put_string",new Prototype([new ArgString],null)),131:new FuncSpec(131,"put_string_stream",new Prototype([arg_class_stream,new ArgString],null)),132:new FuncSpec(132,"put_buffer",new Prototype([new ArgArray(arg_char_native,!1,!0,!1,!0)],null)),133:new FuncSpec(133,"put_buffer_stream",new Prototype([arg_class_stream,new ArgArray(arg_char_native,!1,!0,!1,!0)],null)),134:new FuncSpec(134,"set_style",new Prototype([arg_int_unsigned],null)),135:new FuncSpec(135,"set_style_stream",new Prototype([arg_class_stream,arg_int_unsigned],null)),144:new FuncSpec(144,"get_char_stream",new Prototype([arg_class_stream],new ArgRef(arg_int_signed,!1,!0,!0))),145:new FuncSpec(145,"get_line_stream",new Prototype([arg_class_stream,new ArgArray(arg_char_native,!1,!1,!0,!0)],new ArgRef(arg_int_unsigned,!1,!0,!0))),146:new FuncSpec(146,"get_buffer_stream",new Prototype([arg_class_stream,new ArgArray(arg_char_native,!1,!1,!0,!0)],new ArgRef(arg_int_unsigned,!1,!0,!0))),160:new FuncSpec(160,"char_to_lower",new Prototype([arg_char_unsigned],new ArgRef(arg_char_unsigned,!1,!0,!0))),161:new FuncSpec(161,"char_to_upper",new Prototype([arg_char_unsigned],new ArgRef(arg_char_unsigned,!1,!0,!0))),176:new FuncSpec(176,"stylehint_set",new Prototype([arg_int_unsigned,arg_int_unsigned,arg_int_unsigned,arg_int_signed],null)),177:new FuncSpec(177,"stylehint_clear",new Prototype([arg_int_unsigned,arg_int_unsigned,arg_int_unsigned],null)),178:new FuncSpec(178,"style_distinguish",new Prototype([arg_class_window,arg_int_unsigned,arg_int_unsigned],new ArgRef(arg_int_unsigned,!1,!0,!0))),179:new FuncSpec(179,"style_measure",new Prototype([arg_class_window,arg_int_unsigned,arg_int_unsigned,new ArgRef(arg_int_unsigned,!1,!0,!1)],new ArgRef(arg_int_unsigned,!1,!0,!0))),192:new FuncSpec(192,"select",new Prototype([new ArgRef(new ArgStruct(new Prototype([arg_int_unsigned,arg_class_window,arg_int_unsigned,arg_int_unsigned],null)),!1,!0,!0)],null)),193:new FuncSpec(193,"select_poll",new Prototype([new ArgRef(new ArgStruct(new Prototype([arg_int_unsigned,arg_class_window,arg_int_unsigned,arg_int_unsigned],null)),!1,!0,!0)],null)),208:new FuncSpec(208,"request_line_event",new Prototype([arg_class_window,new ArgArray(arg_char_native,!0,!0,!0,!0),arg_int_unsigned],null)),209:new FuncSpec(209,"cancel_line_event",new Prototype([arg_class_window,new ArgRef(new ArgStruct(new Prototype([arg_int_unsigned,arg_class_window,arg_int_unsigned,arg_int_unsigned],null)),!1,!0,!1)],null)),210:new FuncSpec(210,"request_char_event",new Prototype([arg_class_window],null)),211:new FuncSpec(211,"cancel_char_event",new Prototype([arg_class_window],null)),212:new FuncSpec(212,"request_mouse_event",new Prototype([arg_class_window],null)),213:new FuncSpec(213,"cancel_mouse_event",new Prototype([arg_class_window],null)),214:new FuncSpec(214,"request_timer_events",new Prototype([arg_int_unsigned],null)),224:new FuncSpec(224,"image_get_info",new Prototype([arg_int_unsigned,new ArgRef(arg_int_unsigned,!1,!0,!1),new ArgRef(arg_int_unsigned,!1,!0,!1)],new ArgRef(arg_int_unsigned,!1,!0,!0))),225:new FuncSpec(225,"image_draw",new Prototype([arg_class_window,arg_int_unsigned,arg_int_signed,arg_int_signed],new ArgRef(arg_int_unsigned,!1,!0,!0))),226:new FuncSpec(226,"image_draw_scaled",new Prototype([arg_class_window,arg_int_unsigned,arg_int_signed,arg_int_signed,arg_int_unsigned,arg_int_unsigned],new ArgRef(arg_int_unsigned,!1,!0,!0))),232:new FuncSpec(232,"window_flow_break",new Prototype([arg_class_window],null)),233:new FuncSpec(233,"window_erase_rect",new Prototype([arg_class_window,arg_int_signed,arg_int_signed,arg_int_unsigned,arg_int_unsigned],null)),234:new FuncSpec(234,"window_fill_rect",new Prototype([arg_class_window,arg_int_unsigned,arg_int_signed,arg_int_signed,arg_int_unsigned,arg_int_unsigned],null)),235:new FuncSpec(235,"window_set_background_color",new Prototype([arg_class_window,arg_int_unsigned],null)),240:new FuncSpec(240,"schannel_iterate",new Prototype([arg_class_schannel,new ArgRef(arg_int_unsigned,!1,!0,!1)],new ArgRef(arg_class_schannel,!1,!0,!0))),241:new FuncSpec(241,"schannel_get_rock",new Prototype([arg_class_schannel],new ArgRef(arg_int_unsigned,!1,!0,!0))),242:new FuncSpec(242,"schannel_create",new Prototype([arg_int_unsigned],new ArgRef(arg_class_schannel,!1,!0,!0))),243:new FuncSpec(243,"schannel_destroy",new Prototype([arg_class_schannel],null)),248:new FuncSpec(248,"schannel_play",new Prototype([arg_class_schannel,arg_int_unsigned],new ArgRef(arg_int_unsigned,!1,!0,!0))),249:new FuncSpec(249,"schannel_play_ext",new Prototype([arg_class_schannel,arg_int_unsigned,arg_int_unsigned,arg_int_unsigned],new ArgRef(arg_int_unsigned,!1,!0,!0))),250:new FuncSpec(250,"schannel_stop",new Prototype([arg_class_schannel],null)),251:new FuncSpec(251,"schannel_set_volume",new Prototype([arg_class_schannel,arg_int_unsigned],null)),252:new FuncSpec(252,"sound_load_hint",new Prototype([arg_int_unsigned,arg_int_unsigned],null)),256:new FuncSpec(256,"set_hyperlink",new Prototype([arg_int_unsigned],null)),257:new FuncSpec(257,"set_hyperlink_stream",new Prototype([arg_class_stream,arg_int_unsigned],null)),258:new FuncSpec(258,"request_hyperlink_event",new Prototype([arg_class_window],null)),259:new FuncSpec(259,"cancel_hyperlink_event",new Prototype([arg_class_window],null)),288:new FuncSpec(288,"buffer_to_lower_case_uni",new Prototype([new ArgArray(arg_int_unsigned,!1,!0,!0,!0),arg_int_unsigned],new ArgRef(arg_int_unsigned,!1,!0,!0))),289:new FuncSpec(289,"buffer_to_upper_case_uni",new Prototype([new ArgArray(arg_int_unsigned,!1,!0,!0,!0),arg_int_unsigned],new ArgRef(arg_int_unsigned,!1,!0,!0))),290:new FuncSpec(290,"buffer_to_title_case_uni",new Prototype([new ArgArray(arg_int_unsigned,!1,!0,!0,!0),arg_int_unsigned,arg_int_unsigned],new ArgRef(arg_int_unsigned,!1,!0,!0))),291:new FuncSpec(291,"buffer_canon_decompose_uni",new Prototype([new ArgArray(arg_int_unsigned,!1,!0,!0,!0),arg_int_unsigned],new ArgRef(arg_int_unsigned,!1,!0,!0))),292:new FuncSpec(292,"buffer_canon_normalize_uni",new Prototype([new ArgArray(arg_int_unsigned,!1,!0,!0,!0),arg_int_unsigned],new ArgRef(arg_int_unsigned,!1,!0,!0))),296:new FuncSpec(296,"put_char_uni",new Prototype([arg_int_unsigned],null)),297:new FuncSpec(297,"put_string_uni",new Prototype([new ArgUnicode],null)),298:new FuncSpec(298,"put_buffer_uni",new Prototype([new ArgArray(arg_int_unsigned,!1,!0,!1,!0)],null)),299:new FuncSpec(299,"put_char_stream_uni",new Prototype([arg_class_stream,arg_int_unsigned],null)),300:new FuncSpec(300,"put_string_stream_uni",new Prototype([arg_class_stream,new ArgUnicode],null)),301:new FuncSpec(301,"put_buffer_stream_uni",new Prototype([arg_class_stream,new ArgArray(arg_int_unsigned,!1,!0,!1,!0)],null)),304:new FuncSpec(304,"get_char_stream_uni",new Prototype([arg_class_stream],new ArgRef(arg_int_signed,!1,!0,!0))),305:new FuncSpec(305,"get_buffer_stream_uni",new Prototype([arg_class_stream,new ArgArray(arg_int_unsigned,!1,!1,!0,!0)],new ArgRef(arg_int_unsigned,!1,!0,!0))),306:new FuncSpec(306,"get_line_stream_uni",new Prototype([arg_class_stream,new ArgArray(arg_int_unsigned,!1,!1,!0,!0)],new ArgRef(arg_int_unsigned,!1,!0,!0))),312:new FuncSpec(312,"stream_open_file_uni",new Prototype([arg_class_fileref,arg_int_unsigned,arg_int_unsigned],new ArgRef(arg_class_stream,!1,!0,!0))),313:new FuncSpec(313,"stream_open_memory_uni",new Prototype([new ArgArray(arg_int_unsigned,!0,!0,!0,!0),arg_int_unsigned,arg_int_unsigned],new ArgRef(arg_class_stream,!1,!0,!0))),320:new FuncSpec(320,"request_char_event_uni",new Prototype([arg_class_window],null)),321:new FuncSpec(321,"request_line_event_uni",new Prototype([arg_class_window,new ArgArray(arg_int_unsigned,!0,!0,!0,!0),arg_int_unsigned],null)),336:new FuncSpec(336,"set_echo_line_event",new Prototype([arg_class_window,arg_int_unsigned],null)),337:new FuncSpec(337,"set_terminators_line_event",new Prototype([arg_class_window,new ArgArray(arg_int_unsigned,!1,!0,!1,!1)],null)),352:new FuncSpec(352,"current_time",new Prototype([new ArgRef(new ArgStruct(new Prototype([arg_int_signed,arg_int_unsigned,arg_int_signed],null)),!1,!0,!0)],null)),353:new FuncSpec(353,"current_simple_time",new Prototype([arg_int_unsigned],new ArgRef(arg_int_signed,!1,!0,!0))),360:new FuncSpec(360,"time_to_date_utc",new Prototype([new ArgRef(new ArgStruct(new Prototype([arg_int_signed,arg_int_unsigned,arg_int_signed],null)),!0,!1,!0),new ArgRef(new ArgStruct(new Prototype([arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed],null)),!1,!0,!0)],null)),361:new FuncSpec(361,"time_to_date_local",new Prototype([new ArgRef(new ArgStruct(new Prototype([arg_int_signed,arg_int_unsigned,arg_int_signed],null)),!0,!1,!0),new ArgRef(new ArgStruct(new Prototype([arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed],null)),!1,!0,!0)],null)),362:new FuncSpec(362,"simple_time_to_date_utc",new Prototype([arg_int_signed,arg_int_unsigned,new ArgRef(new ArgStruct(new Prototype([arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed],null)),!1,!0,!0)],null)),363:new FuncSpec(363,"simple_time_to_date_local",new Prototype([arg_int_signed,arg_int_unsigned,new ArgRef(new ArgStruct(new Prototype([arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed],null)),!1,!0,!0)],null)),364:new FuncSpec(364,"date_to_time_utc",new Prototype([new ArgRef(new ArgStruct(new Prototype([arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed],null)),!0,!1,!0),new ArgRef(new ArgStruct(new Prototype([arg_int_signed,arg_int_unsigned,arg_int_signed],null)),!1,!0,!0)],null)),365:new FuncSpec(365,"date_to_time_local",new Prototype([new ArgRef(new ArgStruct(new Prototype([arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed],null)),!0,!1,!0),new ArgRef(new ArgStruct(new Prototype([arg_int_signed,arg_int_unsigned,arg_int_signed],null)),!1,!0,!0)],null)),366:new FuncSpec(366,"date_to_simple_time_utc",new Prototype([new ArgRef(new ArgStruct(new Prototype([arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed],null)),!0,!1,!0),arg_int_unsigned],new ArgRef(arg_int_signed,!1,!0,!0))),367:new FuncSpec(367,"date_to_simple_time_local",new Prototype([new ArgRef(new ArgStruct(new Prototype([arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed,arg_int_signed],null)),!0,!1,!0),arg_int_unsigned],new ArgRef(arg_int_signed,!1,!0,!0)))},function_map={},blocked_selector=null,blocked_callargs=null,temp_arg_arrays=[],retained_arrays=[],class_map={},last_used_id;
return init_module(),{set_vm:set_vm,get_function:get_function,prepare_resume:prepare_resume,class_register:class_register,class_unregister:class_unregister,class_obj_to_id:class_obj_to_id,class_obj_from_id:class_obj_from_id,retain_array:retain_array,unretain_array:unretain_array}}();